<?php
// +----------------------------------------------------------------------+
// | webEdition                                                           |
// +----------------------------------------------------------------------+
// | PHP version 4.1.0 or greater                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2000 - 2008 living-e AG                                |
// +----------------------------------------------------------------------+
//

/**
 * @abstract class representing the model data of the search
 * @author Thomas Kneip
 * @copyright living-e AG
 */

// remove trailing slash
if (isset($_SERVER["DOCUMENT"."_ROOT"]) && substr($_SERVER["DOCUMENT"."_ROOT"],-1) == "/") {
	$_SERVER["DOCUMENT"."_ROOT"] = substr($_SERVER["DOCUMENT"."_ROOT"],0,-1);
}
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_tools/Suche/conf/define.conf.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_classes/tools/weToolModel.class.php');

class searchtool extends weToolModel {
	
	/**
	 * @var integer: default ParentId in which own searches are saved
	 */
	var $ParentID = 8;
	
	/**
	 * @var string: classname
	 */
	var $ModelClassName = 'searchtool';
	
	/**
	 * @var string: name of the icon in the tree
	 */
	var $Icon = 'Suche.gif';
	
	/**
	 * @var string: toolname
	 */
	var $toolName = 'Suche';
	
	/**
	 * @var tinyint: flag if the search ist predefined or not
	 */
	var $predefined;
	
	/**
	 * for each search there are seperate variables
	 * 
	 * @var integer: position to start the search
	 */
	var $searchstartDocSearch = 0;
	var $searchstartTmplSearch = 0;
	var $searchstartAdvSearch = 0;
	
	/**
	 * @var array: includes the text to search for
	 */
	var $searchDocSearch = array ( );
	var $searchTmplSearch = array ( );
	var $searchAdvSearch = array ( );
	
	/**
	 * @var array: includes the operators
	 */
	var $locationDocSearch = array ( );
	var $locationTmplSearch = array ( );
	var $locationAdvSearch = array ( );
	
	/**
	 * @var tinyint: flag that shows what you are searching for in the docsearch
	 */
	var $searchForTextDocSearch = 1;
	var $searchForTitleDocSearch = 0;
	var $searchForContentDocSearch = 0;
	
	/**
	 * @var tinyint: flag that shows what you are searching for in the tmplsearch
	 */
	var $searchForTextTmplSearch = 1;
	var $searchForContentTmplSearch = 0;
	
	/**
	 * @var array: shows which tables you have to search in in the advsearch
	 */
	var $search_tables_advSearch = array ( );
	
	/**
	 * @var integer: folder-ids of the docsearch and the tmplsearch
	 */
	var $folderIDDoc;
	var $folderIDTmpl;
	
	/**
	 * @var tinyint: flag that shows what view is set in each search
	 */
	var $setViewDocSearch = 0;
	var $setViewTmplSearch = 0;
	var $setViewAdvSearch = 0;
	
	/**
	 * @var int: gives the number of entries in each search for one page
	 */
	var $anzahlDocSearch = 10;
	var $anzahlTmplSearch = 10;
	var $anzahlAdvSearch = 10;
	
	/**
	 * @var string: gives the order
	 */
	var $OrderDocSearch = "Text";
	var $OrderTmplSearch = "Text";
	var $OrderAdvSearch = "Text";
	
	/**
	 * @var array: includes the searchfiels which you are searching in
	 */
	var $searchFieldsDocSearch = array ( );
	var $searchFieldsTmplSearch = array ( );
	var $searchFieldsAdvSearch = array ( );
	
	
	var $activTab = 1;
	
	/**
	 * Default Constructor
	 * Can load or create new searchtool object depends of parameter
	 */
	
	function searchtool($SucheID = 0) {
		
		parent::weToolModel ( SUCHE_TABLE );
		
		if ($SucheID) {
			$this->ID = $SucheID;
			$this->load ( $SucheID );
		}
	
	}
	
	function setIsFolder($value) {
		
		$this->IsFolder = $value;
		
		if ($value) {
			$this->Icon = 'folder.gif';
		} else {
			$this->Icon = 'Suche.gif';
		}

	}
	
	function getLangText($id, $text) {
		
		if($GLOBALS['_language']['charset']=="UTF-8") {
			$text = iconv("ISO-8859-1","UTF-8",$text);
		}
		
		 $_text = $text;
		 switch ($id) {
          case 1:
              $_text = $GLOBALS['l_Suche']['vordefinierteSuchanfragen'];
              break;
          case 2:
              $_text = $GLOBALS['l_Suche']['dokumente'];
              break;
          case 3:
              $_text = $GLOBALS['l_Suche']['objekte'];
              break;
          case 4:
              $_text = $GLOBALS['l_Suche']['unveroeffentlicheDokumente'];
              break;
          case 5:
              $_text = $GLOBALS['l_Suche']['statischeDokumente'];
              break;
          case 6:
              $_text = $GLOBALS['l_Suche']['dynamischeDokumente'];
              break;
          case 7:
              $_text = $GLOBALS['l_Suche']['unveroeffentlicheObjekte'];
              break;
          case 8:
              $_text = $GLOBALS['l_Suche']['eigeneSuchanfragen'];
              break;
      }
      
      return $_text;
      
	}

}
?>