<?php

// +----------------------------------------------------------------------+
// | webEdition                                                           |
// +----------------------------------------------------------------------+
// | PHP version 4.1.0 or greater                                         |
// +----------------------------------------------------------------------+
// | Copyright (c) 2000 - 2007 living-e AG                                |
// +----------------------------------------------------------------------+
//


include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we.inc.php');

include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/modules/weModuleFrames.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/html/we_forms.inc.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_language/' . $GLOBALS['WE_LANGUAGE'] . '/navigation.inc.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/navigation/weNavigationView.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/navigation/weNavigationTree.php');

class weNavigationFrames extends weModuleFrames {

	var $View;

	var $_space_size = 120;
	var $_text_size = 75;
	var $_width_size = 520;
	var $_def_box_style = 'float:left;';
	var $_margin_bottom = '5px';
	var $_margin_top = '5px';

	function weNavigationFrames() {
		$_frameset = '/webEdition/we/include/we_tools/navigation/edit_navigation_frameset.php';
		$this->weModuleFrames($_frameset);
		$this->Tree=new weNavigationTree();
		$this->View = new weNavigationView($_frameset,'top');
		$this->setTree(NAVIGATION_TABLE,'top','top.resize.left.tree','top.cmd');
		$this->module = 'navigation';
	}

	function getHTML($what){

		switch($what){
			case 'frameset': print $this->getHTMLFrameset();break;
			case 'header': print $this->getHTMLHeader();break;
			case 'resize': print $this->getHTMLResize();break;
			case 'left':  print $this->getHTMLLeft();break;
			case 'right': print $this->getHTMLRight();break;
			case 'editor': print $this->getHTMLEditor();break;
			case 'edheader': print $this->getHTMLEditorHeader();break;
			case 'preview':
			case 'edbody': print $this->getHTMLEditorBody(); break;
			case 'previewIframe': print $this->getHTMLEditorPreviewIframe(); break;
			case 'edfooter': print $this->getHTMLEditorFooter();break;
			case 'cmd': print $this->getHTMLCmd();break;
			case 'treeheader': print $this->getHTMLTreeHeader();break;
			case 'treefooter': print $this->getHTMLTreeFooter();break;
			case 'fields': print $this->getHTMLFieldSelector();break;
			case 'dyn_preview': print $this->getHTMLDynPreview();break;
			case 'treeconst': print $this->Tree->getHTMLContruct();break;
			case 'exit_doc_question': print $this->getHTMLExitQuestion();break;
			default:
				error_log(__FILE__ . " unknown reference: $what");
		}
	}

	function getHTMLFrameset(){
		$this->View->navigation->clearSessionVars();
		return weModuleFrames::getHTMLFrameset();
	}

	function getJSCmdCode(){
		return $this->View->getJSTop() .
				we_htmlElement::jsElement($this->Tree->getJSMakeNewEntry()
		);
	}

	/**
	 * Top frame with menu
	 *
	 * @return string
	 */
	function getHTMLHeader(){
		global $l_customer;

		//	Include the menu.
		include($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/java_menu/weJavaMenu.inc.php');
		include($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/java_menu/we_menu_navigation.inc.php');

		$port = defined('HTTP_PORT') ? HTTP_PORT : '';
		$lang_arr='we_menu_navigation';
		$jmenu = new weJavaMenu($$lang_arr,SERVER_NAME, $this->topFrame .'.cmd',getServerProtocol(),$port,350,30);

		$menu='';
		ob_start();
		$jmenu->printMenu();
		$menu=ob_get_contents();
		ob_end_clean();

		$table=new we_htmlTable(array("width"=>"100%","cellpadding"=>"0","cellspacing"=>"0","border"=>"0"),1,1);
		$table->setCol(0,0,array("align"=>"left","valign"=>"top"),$menu);

		$body=we_htmlElement::htmlBody(array("bgcolor"=>"#bfbfbf","background"=>IMAGE_DIR."java_menu/background.gif","marginwidth"=>"0","marginheight"=>"0","leftmargin"=>"0","topmargin"=>"0"),
						$table->getHtmlCode()
		);

		return $this->getHTMLDocument($body);

	}

	/**
	 * Frame for tubs
	 *
	 * @return string
	 */
	function getHTMLEditorHeader() {
		global $l_navigation;

		if(!empty($this->View->navigation->Charset)) {
				header('Content-Type: text/html; charset=' . $this->View->navigation->Charset);
		}

		require_once($_SERVER['DOCUMENT_ROOT'].'/webEdition/we/include/we_classes/we_tabs.class.inc.php');
		if(isset($_REQUEST['home'])){
			return $this->getHTMLDocument(we_htmlElement::htmlBody(array('bgcolor'=>'#F0EFF0','background'=>'/webEdition/images/backgrounds/bgGrayLineTop.gif'),''));
		}

		$we_tabs = new we_tabs();

		$we_tabs->addTab(new we_tab('#',$l_navigation['property'],'(('.$this->topFrame.'.activ_tab==1) ? TAB_ACTIVE : TAB_NORMAL)',"setTab('1');",array("id"=>"tab_1")));
		if($this->View->navigation->IsFolder) {
			$we_tabs->addTab(new we_tab("#",$l_navigation['content'],'(('.$this->topFrame.'.activ_tab==2) ? TAB_ACTIVE : TAB_NORMAL)',"setTab('2');",array("id"=>"tab_2")));
		}

		if(defined('CUSTOMER_TABLE')) {
			$we_tabs->addTab(new we_tab("#",$l_navigation['customers'],'(('.$this->topFrame.'.activ_tab==3) ? TAB_ACTIVE : TAB_NORMAL)',"setTab('3');",array("id"=>"tab_3")));
		}

		if($this->View->navigation->IsFolder) {
			$we_tabs->addTab(new we_tab("#",$l_navigation['preview'],'(('.$this->topFrame.'.activ_tab=="preview") ? TAB_ACTIVE : TAB_NORMAL)',"setTab('preview');",array("id"=>"tab_preview")));
		}

		$we_tabs->onResize();
		$tabsHead = $we_tabs->getHeader();
		$tabsBody = $we_tabs->getJS();

		$js = '';

		if($this->View->navigation->IsFolder==0) {
			$js=we_htmlElement::jsElement('
				if('.$this->View->topFrame.'.activ_tab!=1 && '.$this->View->topFrame.'.activ_tab!=3) {
					'.$this->View->topFrame.'.activ_tab=1;
				}
			');
		}

		$js.=we_htmlElement::jsElement('

				function mark() {
					var elem = document.getElementById("mark");
					elem.style.display = "inline";

				}

				function unmark() {
					var elem = document.getElementById("mark");
					elem.style.display = "none";
				}

				function setTab(tab) {
					switch (tab) {
						case "preview":	// submit the information to preview screen
							parent.edbody.document.we_form.cmd.value="";
							if ('.$this->topFrame.'.activ_tab != tab || ('.$this->topFrame.'.activ_tab=="preview" && tab=="preview")) {
								parent.edbody.document.we_form.pnt.value = "preview";
								parent.edbody.document.we_form.tabnr.value = "preview";
								parent.edbody.submitForm();
							}
						break;

						default: // just toggle content to show
							if ('.$this->topFrame.'.activ_tab!="preview") {
								parent.edbody.toggle("tab"+'.$this->topFrame.'.activ_tab);
								parent.edbody.toggle("tab"+tab);
								'.$this->topFrame.'.activ_tab=tab;
								self.focus();
							} else {

								parent.edbody.document.we_form.pnt.value = "edbody";
								parent.edbody.document.we_form.tabnr.value = tab;
								parent.edbody.submitForm();
							}
						break;
					}
					self.focus();
					'.$this->topFrame.'.activ_tab=tab;
				}

				'.($this->View->navigation->ID ? '' : $this->topFrame.'.activ_tab=1;').'
		');

		$tabsHead .= $js;

		$table=new we_htmlTable(array("width"=>"3000","cellpadding"=>"0","cellspacing"=>"0","border"=>"0"),3,1);

		$table->setCol(0,0,array(),getPixel(1,3));

		$_text = $this->View->navigation->Text;
		$_text = str_replace("<br>","&crarr;",$_text);
		$_text = str_replace("<br/>","&crarr;",$_text);
		$this->View->navigation->Text = $_text;

		$table->setCol(1,0,array("valign"=>"top","class"=>"small"),
							getPixel(15,2).
							we_htmlElement::htmlB(
								($this->View->navigation->IsFolder ? $l_navigation['group'] : $l_navigation['entry']) . ':&nbsp;'. str_replace('&amp;','&',$this->View->navigation->Text) . '<div id="mark" style="display: none;">*</div>' .
								we_htmlElement::htmlImg(array("align"=>"absmiddle","height"=>"19","width"=>"1600","src"=>IMAGE_DIR."pixel.gif"))
							)
		);

		$extraJS = 'document.getElementById("tab_"+'.$this->topFrame.'.activ_tab).className="tabActive";';
		$body=we_htmlElement::htmlBody(array("bgcolor"=>"white","background"=>IMAGE_DIR."backgrounds/header_with_black_line.gif","marginwidth"=>"0","marginheight"=>"0","leftmargin"=>"0","topmargin"=>"0", "onload"=>"setFrameSize()", "onresize"=>"setFrameSize()"),
			'<div id="main" >' . getPixel(100,3) . '<div style="margin:0px;" id="headrow">&nbsp;'.we_htmlElement::htmlB(($this->View->navigation->IsFolder ? $l_navigation['group'] : $l_navigation['entry']) . ':&nbsp;'. str_replace('&amp;','&',$this->View->navigation->Text) . '<div id="mark" style="display: none;">*</div>').'</div>' . getPixel(100,3) .
			$we_tabs->getHTML() .
			'</div>' . we_htmlElement::jsElement($extraJS)
//			$js.
//			$table->getHtmlCode() .
//			$tabsBody
		);

		return $this->getHTMLDocument($body,$tabsHead);

	}



	function getHTMLEditorBody() {

		$hiddens=array('cmd'=>'edit_navigation','pnt'=>'edbody','vernr'=>(isset($_REQUEST['vernr']) ? $_REQUEST['vernr'] : 0));

		if(isset($_REQUEST["home"]) && $_REQUEST["home"]){
			$hiddens['cmd']='home';
			$GLOBALS['we_print_not_htmltop'] = true;
			$GLOBALS['we_head_insert'] = $this->View->getJSProperty();
			$GLOBALS['we_body_insert'] = we_htmlElement::htmlForm(array('name'=>'we_form'),
					$this->View->getCommonHiddens($hiddens).we_htmlelement::htmlHidden(array('name'=>'home', 'value'=>'0'))
			);
			$GLOBALS['mod'] = 'navigation';
			ob_start();
			include($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_modules/home.inc.php');
            $out = ob_get_contents();
            ob_end_clean();
            return
            we_htmlElement::jsElement('
								'.$this->topFrame.'.resize.right.editor.edheader.location="'.$this->frameset.'?pnt=edheader&home=1";
								'.$this->topFrame.'.resize.right.editor.edfooter.location="'.$this->frameset.'?pnt=edfooter&home=1";
			') . $out;

		}

		$body=we_htmlElement::htmlBody(array("class"=>"weEditorBody",'onLoad'=>'loaded=1;setFocus();'),
					we_htmlElement::jsElement('',array('src'=>JS_DIR.'utils/multi_edit.js?'.WE_VERSION)) .
					we_htmlElement::htmlForm(array('name'=>'we_form','onsubmit'=>'return false'),
						$this->getHTMLProperties()
					)
		);

		return $this->getHTMLDocument($body,STYLESHEET . $this->View->getJSProperty());

	}

	function getHTMLEditorFooter() {

		if(isset($_REQUEST["home"])){
			return $this->getHTMLDocument(we_htmlElement::htmlBody(array("bgcolor"=>"#F0EFF0"),""));
		}

		$we_button = new we_button();

		$table1=new we_htmlTable(array("border"=>"0","cellpadding"=>"0","cellspacing"=>"0","width"=>"3000"),1,1);
		$table1->setCol(0,0,array("nowrap"=>null,"valign"=>"top"),getPixel(1600,10));


		$_but_table = $we_button->create_button_table(array(
				$we_button->create_button("save", "javascript:top.we_cmd('save_navigation')",true,100,22,'','',(!we_hasPerm('EDIT_NAVIGATION')))
			),10 , array('style'=>'margin-left: 15px')
		);

		return $this->getHTMLDocument(
					we_htmlElement::htmlBody(array("bgcolor"=>"white","background"=>"/webEdition/images/edit/editfooterback.gif","marginwidth"=>"0","marginheight"=>"0","leftmargin"=>"0","topmargin"=>"0"),
							we_htmlElement::htmlForm(array(),$table1->getHtmlCode().
							$_but_table)
					)

		);

	}


	function getPercent($total, $value, $precision=0){

		if ($total) {
			$result = round(($value*100)/$total,$precision);
		} else {
			$result = 0;
		}

		return weNavigation::formatNumber($result,strtolower($GLOBALS['WE_LANGUAGE']),2);
	}

	function getHTMLGeneral(){
		global $l_navigation;

		$we_button = new we_button();
		$parts = array();

		$_table=new we_htmlTable(array('border'=>'0','cellpadding'=>'0','cellspacing'=>'0','width'=>'300','style'=>'margin-top:'.$this->_margin_top.';'),1,3);

		$_table->setCol(0,0,array('class'=>'defaultfont'),
				$l_navigation['order'] . ':'
		);

		$_table->setColContent(0,1,
				htmlTextInput('Ordn','',($this->View->navigation->Ordn+1),'','disabled="true" readonly style="width: 35px" onBlur="var r=parseInt(this.value);if(isNaN(r)) this.value='.$this->View->navigation->Ordn.'; else{ this.value=r; '.$this->topFrame.'.mark();}"')
		);

		$_parentid = f('SELECT ParentID FROM '.NAVIGATION_TABLE.' WHERE ID='.$this->View->navigation->ID.';','ParentID',$this->db);
		$_num = f('SELECT COUNT(ID) as OrdCount FROM '.NAVIGATION_TABLE.' WHERE ParentID='.$_parentid.';','OrdCount',new DB_WE());

		$_table->setColContent(0,2,
				$we_button->create_button_table(array(
					$we_button->create_button('image:direction_up', 'javascript:'.$this->topFrame.'.we_cmd("move_up");',true,100,22,'','',(($this->View->navigation->Ordn>0) ? false : true),false),
					$we_button->create_button('image:direction_down', 'javascript:'.$this->topFrame.'.we_cmd("move_down");',true,100,22,'','',(($this->View->navigation->Ordn<($_num-1)) ? false : true),false)
				),10 , array('style'=>'margin-left: 15px'))
		);

		array_push($parts,array(
				'headline'=> $l_navigation['general'],
				'html'=>	we_htmlElement::htmlHidden(array('name'=>'newone','value'=>($this->View->navigation->ID==0 ? 1 : 0))) .
							htmlFormElementTable(htmlTextInput('Text','',strtr($this->View->navigation->Text, array_flip(get_html_translation_table(HTML_SPECIALCHARS))),'','style="width: '.$this->_width_size.'" onChange="'.$this->topFrame.'.mark();"'), $l_navigation['name']) .
							$this->getHTMLChooser($l_navigation['group'],NAVIGATION_TABLE,0,'ParentID',$this->View->navigation->ParentID,'ParentPath','opener.'.$this->topFrame.'.mark()','',($this->View->navigation->IsFolder==0 && $this->View->navigation->Depended==1)),
				'space'=>$this->_space_size,
				'noline'=>1
				)
		);

		array_push($parts,array(
				'headline'=> '',
				'html'=> $_table->getHtmlCode(),
				'space'=>$this->_space_size,
				'noline'=>1
				)
		);

		$uniqname = 'weIconNaviAttrib';
		$wepos = weGetCookieVariable("but_weIconNaviAttrib");
		$wepos = ($wepos=='right' || $wepos=='down') ? $wepos : 'right';
		$iconIdValue = $this->View->navigation->IconID == 0 ? '' : $this->View->navigation->IconID;
		array_push($parts,array(
				'headline'=> '',
				'html'=>	$this->getHTMLChooser($l_navigation['icon'],FILE_TABLE,0,'IconID',$iconIdValue,'IconPath','opener.'.$this->topFrame.'.mark()','image/*',false,true) .
							getPixel($this->_width_size,10) .
							'<table><tr><td>' .
							we_multiIconBox::getJS() .
							we_multiIconBox::_getButton($uniqname,"weToggleBox('$uniqname','".addslashes($l_navigation['icon_properties_out'])."','".addslashes($l_navigation['icon_properties'])."')",$wepos,$GLOBALS["l_global"]["openCloseBox"]) .
							'</td><td><span style="cursor: pointer;-moz-user-select: none;" class="defaultfont" id="text_'.$uniqname.'" onClick="weToggleBox(\''.$uniqname.'\',\''.addslashes($l_navigation['icon_properties_out']).'\',\''.addslashes($l_navigation['icon_properties']).'\');" unselectable="on">'.($wepos=='down' ? $l_navigation['icon_properties_out'] : $l_navigation['icon_properties']).'</span></td></tr></table>',



				'space'=>$this->_space_size,
				'noline'=>1
				)
		);

		array_push($parts,array(
				'headline'=> '',
				'html'=> '<div id="table_'.$uniqname.'" style="display: '.($wepos=='down' ? 'block' : 'none').';">' . $this->getHTMLImageAttributes() . '</div>',
				'space'=>$this->_space_size+50,
				'noline'=>1
				)
		);

		return $parts;
	}

	function getHTMLPropertiesItem() {
		global $l_navigation;

		$parts = array();

		if($this->View->navigation->Selection=="dynamic") {
			$_seltype = array('doctype'=>$l_navigation['documents']);
			if(defined('OBJECT_TABLE')) {
				$_seltype['classname']=$l_navigation['objects'];
			}
			$_seltype['category']=$l_navigation['categories'];

		} else {
			$_seltype = array(
				'docLink'=>$l_navigation['docLink'],
				'urlLink'=>$l_navigation['urlLink']
			);
			if(defined('OBJECT_TABLE')) {
				$_seltype['objLink']=$l_navigation['objLink'];
			}
			$_seltype['catLink']=$l_navigation['catLink'];
		}

		$_selection_block =
			$this->View->navigation->Depended==1 ?
			$this->getHTMLDependedProfile()
			:
			$this->View->htmlHidden('CategoriesControl',(isset($_REQUEST['CategoriesCount']) ? $_REQUEST['CategoriesCount'] : 0)) .
			$this->View->htmlHidden('SortControl',(isset($_REQUEST['SortCount']) ? $_REQUEST['SortCount'] : 0)) .
			$this->View->htmlHidden('CategoriesCount',(isset($this->View->navigation->Categories) ? count($this->View->navigation->Categories) : '0')) .
			$this->View->htmlHidden('SortCount',(isset($this->View->navigation->Sort) ? count($this->View->navigation->Sort) : '0')) .
			'
			<div style="display: block;">
			' .
			htmlSelect('Selection',array('dynamic'=>$l_navigation['dyn_selection'],'static'=>$l_navigation['stat_selection']),1,$this->View->navigation->Selection,false,'style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;" onChange="closeAllSelection();toggle(this.value);setPresentation(this.value);setWorkspaces(\'\');'.$this->topFrame.'.mark();"','value') .
			'<br />'.
			htmlSelect('SelectionType',$_seltype,1,$this->View->navigation->SelectionType,false,'onChange="closeAllType();clearFields();closeAllStats();toggle(this.value);setWorkspaces(this.value);setStaticSelection(this.value);'.$this->topFrame.'.mark();" style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px; margin-top: ' . $this->_margin_top . ';"','value',$this->_width_size) .

			'
			<div id="dynamic" style="' . ($this->View->navigation->Selection=='dynamic' ? 'display: block;' : 'display: none;') .'">
				'.
				$this->getHTMLDynamic()
				.'
			</div>
			<div id="static" style="' . ($this->View->navigation->Selection=='static' ? 'display: block;' : 'display: none;') .'">

				<div id="staticSelect" style="' . ($this->View->navigation->SelectionType!='urlLink' ? 'display: block;' : 'display: none;') .'">
				' .

				$this->getHTMLStatic()
				. '
				</div>
				<div id="staticUrl" style="' . (($this->View->navigation->SelectionType=='catLink' || $this->View->navigation->SelectionType=='urlLink') ? 'display: block;' : 'display: none;') .';margin-top:'.$this->_margin_top.';">
				'.
				//htmlFormElementTable(htmlTextInput('Url',58,$this->View->navigation->Url,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),$l_navigation['urlLink']) .

				$this->getHTMLLink()
				.'
				</div>
				<div style="margin-top:'.$this->_margin_top.';">
				'.
				htmlFormElementTable(htmlTextInput('Parameter',58,$this->View->navigation->Parameter,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size,0),$l_navigation['parameter'])
				.'
				</div>
			</div>
			</div>
		';

		array_push($parts,
					array(
						'headline' => $l_navigation['selection'],
						'html' =>	$_selection_block,
						'space' => $this->_space_size,
						'noline' => 1
					)
		);

		return $parts;
	}

	function  getHTMLPropertiesGroup() {

		global $l_navigation;

		$we_button = new we_button();
		$parts = array();

		$rootDirID = 0;
		$_cmd_doc = "javascript:we_cmd('openDocselector',document.we_form.elements['LinkID'].value,'".FILE_TABLE."','document.we_form.elements[\\'LinkID\\'].value','document.we_form.elements[\\'LinkPath\\'].value','','".session_id()."','$rootDirID','',".(we_hasPerm("CAN_SELECT_OTHER_USERS_FILES") ? 0 : 1).")";
		$_cmd_obj = defined('OBJECT_TABLE') ? "javascript:we_cmd('openDocselector',document.we_form.elements['LinkID'].value,'".OBJECT_FILES_TABLE."','document.we_form.elements[\\'LinkID\\'].value','document.we_form.elements[\\'LinkPath\\'].value','opener.".$this->topFrame.".we_cmd(\"populateFolderWs\");','".session_id()."','$rootDirID','objectFile',".(we_hasPerm("CAN_SELECT_OTHER_USERS_OBJECTS") ? 0 : 1).")" : '';

		$_button_doc = $we_button->create_button('select', $_cmd_doc,true,100,22,'','',false);
		$_button_obj = $we_button->create_button('select', $_cmd_obj,true,100,22,'','',false);

		$_buttons = '<div id="docFolderLink" style="display: '.((empty($this->View->navigation->FolderSelection) || $this->View->navigation->FolderSelection=='docLink') ? 'inline' : 'none').'">' .
					$_button_doc .
					'</div>' .
					'<div id="objFolderLink" style="display: '.($this->View->navigation->FolderSelection=='objLink' ? 'inline' : 'none').'">' .
					$_button_obj .
					'</div>';

		$_path = id_to_path($this->View->navigation->LinkID,($this->View->navigation->FolderSelection=='docLink' ? FILE_TABLE : (defined('OBJECT_TABLE') && $this->View->navigation->FolderSelection=='objLink' ? OBJECT_FILES_TABLE : FILE_TABLE)));

		$_seltype = array('docLink'=>$l_navigation['docLink'],'urlLink'=>$l_navigation['urlLink']);
		if(defined('OBJECT_TABLE')) {
				$_seltype['objLink']=$l_navigation['objLink'];
		};

		$_selection = '
		<div style="display: block;">
		' .htmlSelect('FolderSelection',$_seltype,1,$this->View->navigation->FolderSelection,false,'onChange="setFolderSelection(this.value);'.$this->topFrame.'.mark();" style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px; margin-top: ' . $this->_margin_top . ';"','value',$this->_width_size) . '

		<div id="folderSelectionDiv" style="display: '.($this->View->navigation->FolderSelection!='urlLink' ? 'block' : 'none').';margin-top:'.$this->_margin_top.'">' .
		htmlFormElementTable(htmlTextInput('LinkPath',58,$_path,'','onchange="'.$this->topFrame.'.mark();" readonly','text',($this->_width_size-120),0),
			'',
			'left',
			'defaultfont',
			we_htmlElement::htmlHidden(array('name'=>'LinkID',"value"=>$this->View->navigation->LinkID)),
			getPixel(20,4),
			$_buttons
		) . '</div>

		</div>
		<div id="folderUrlDiv" style="display: '.($this->View->navigation->FolderSelection=='urlLink' ? 'block' : 'none').'; margin-top:'.$this->_margin_top.'">
			'.
			htmlTextInput('FolderUrl',58,$this->View->navigation->FolderUrl,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size,0)
			.'
		</div>
		' . $this->getHTMLWorkspace('object',0,'FolderWsID')
		. htmlFormElementTable(htmlTextInput('FolderParameter',58,$this->View->navigation->FolderParameter,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size,0),$l_navigation['parameter'])
		;

		array_push($parts,
					array(
						'headline' => $l_navigation['selection'],
						'html' => $_selection,
						'space' => $this->_space_size,
						'noline' => 1
					)
		);

		if(function_exists('mb_convert_encoding')){
			array_push($parts,
						array(
							'headline' => $l_navigation['charset'],
							'html' => 	htmlAlertAttentionBox($l_navigation['charset_desc'],2,$this->_width_size) .
										$this->getHTMLCharsetTable(),
							'space' => $this->_space_size,
							'noline' => 1
						)
			);
		}

		return $parts;

	}

	function getHTMLDependedProfile() {
		global $l_navigation;

		$parts = array();

		if($this->View->navigation->Selection=="dynamic") {
			$_seltype = array('doctype'=>$l_navigation['documents']);
			if(defined('OBJECT_TABLE')) {
				$_seltype['classname']=$l_navigation['objects'];
			}
		} else {
			$_seltype = array('docLink'=>$l_navigation['docLink']);
			if(defined('OBJECT_TABLE')) {
				$_seltype['objLink']=$l_navigation['objLink'];
			}
		}

		$_table=new we_htmlTable(array('width'=>$this->_width_size,'cellpadding'=>'0','cellspacing'=>'2','border'=>'0','class'=>'defaultfont'),5,2);


		$_table->setColContent(0,0,$l_navigation['stat_selection']);

		$_table->setColContent(1,0,
				($this->View->navigation->SelectionType=='catLink' ? $l_navigation['catLink'] : ($this->View->navigation->SelectionType=='docLink' ? $l_navigation['docLink'] :  $l_navigation['objLink'])). ':'
		);

		$_table->setColContent(1,1,
			id_to_path($this->View->navigation->LinkID,($this->View->navigation->SelectionType=='catLink' ? CATEGORY_TABLE : ($this->View->navigation->SelectionType=='docLink' ? FILE_TABLE : OBJECT_FILES_TABLE)))
		);

		if(!empty($this->View->navigation->Url) && $this->View->navigation->Url!='http://') {
			$_table->setColContent(2,0,
				$l_navigation['linkSelection']. ':'
			);

			$_table->setColContent(2,1,
				$this->View->navigation->Url
			);
		} else if(!empty($this->View->navigation->UrlID) && $this->View->navigation->UrlID) {
			$_table->setColContent(2,0,
				$l_navigation['linkSelection']. ':'
			);

			$_table->setColContent(2,1,
				id_to_path($this->View->navigation->UrlID)
			);
		}

		if($this->View->navigation->SelectionType=='catLink') {
			$_table->setColContent(3,0,
				$l_navigation['catParameter']. ':'
			);
			$_table->setColContent(3,1,
				$this->View->navigation->CatParameter
			);
		}


		if(!empty($this->View->navigation->Parameter)) {
			$_table->setColContent(4,0,
				$l_navigation['parameter']. ':'
			);

			$_table->setColContent(4,1,
				$this->View->navigation->Parameter
			);
		}



		return $_table->getHtmlCode();


		$_selection_block =
			'
			<div style="display: block;">
			' .
				$l_navigation['stat_selection'] . '<br />' .
				($this->View->navigation->SelectionType=='catLink' ? $l_navigation['catLink'] : ($this->View->navigation->SelectionType=='docLink' ? $l_navigation['docLink'] :  $l_navigation['objLink'])).
				':' . id_to_path($this->View->navigation->LinkID,($this->View->navigation->SelectionType=='catLink' ? CATEGORY_TABLE : ($this->View->navigation->SelectionType=='docLink' ? FILE_TABLE : OBJECT_FILES_TABLE))) . '
			</div>
			<div>
			'.

			$this->View->navigation->Parameter
			.'
			</div>

		';



		return $_selection_block;

	}

	function getHTMLDynamic() {
		global $l_navigation;

		$docTypes = array(0=>$l_navigation['no_entry']);
		$q = getDoctypeQuery($this->db);
		$this->db->query("SELECT ID,DocType FROM " . DOC_TYPES_TABLE . " $q");
		while($this->db->next_record()){
			$docTypes[$this->db->f("ID")] = $this->db->f('DocType');
		}

		$objectDirs = array();
		$classNames = array();
		$objectDirs = array();
		$objectPaths = array();
		$allowedClasses = getAllowedClasses($this->db);

		if(defined('OBJECT_TABLE')){

			$_firstClass = 0;
			$this->db->query("SELECT DISTINCT  ".OBJECT_TABLE . ".ID,".OBJECT_TABLE . ".Text,".OBJECT_FILES_TABLE . ".ParentID FROM ".OBJECT_TABLE . " LEFT JOIN " . OBJECT_FILES_TABLE . " ON (" . OBJECT_TABLE .".ID=" . OBJECT_FILES_TABLE . ".TableID)");
			while($this->db->next_record()){
				if (in_array($this->db->f('ID'),$allowedClasses)) {
					if(!$_firstClass){
						$_firstClass = $this->db->f('ID');
					}
					$classNames[$this->db->f('ID')] = $this->db->f('Text');
					$objectDirs[] = $this->db->f('ID') . ':' . abs($this->db->f('ParentID'));
					$objectPaths[] = $this->db->f('ID') . ':"' . f('SELECT Path FROM ' . OBJECT_FILES_TABLE . ' WHERE ID=' . $this->db->f('ParentID'),'Path',new DB_WE()) . '"';
				}
			}
		}

		$we_button = new we_button();

		$_wsid = array();
		if($this->View->navigation->SelectionType=='objLink' && $this->View->navigation->LinkID){
			require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/navigation/weDynList.class.php');
			$_wsid = weDynList::getWorkspacesForObject($this->View->navigation->LinkID);
		}

		return
		we_htmlElement::jsElement('
			objectDirs = {' . implode(',',$objectDirs) . '};
			objectPaths = {' . implode(',',$objectPaths) . '};
		') .
		'
		<div style="display: block;">
			<div id="doctype" style="' . ($this->View->navigation->SelectionType=='doctype' ? 'display: block' : 'display: none') . '; width: ' . $this->_width_size . ';margin-top:'.$this->_margin_top.'">
				' .
				htmlFormElementTable(htmlSelect('DocTypeID',$docTypes,1,$this->View->navigation->DocTypeID,false,'onChange="clearFields();'.$this->topFrame.'.mark();" style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;"','value'),$l_navigation['doctype'])
				.'
			</div>
			<div id="classname" style="' . ($this->View->navigation->SelectionType=='classname' ? 'display: block' : 'display: none') . '; width: ' . $this->_width_size . ';margin-top:'.$this->_margin_top.';">
				'.(defined('OBJECT_TABLE') ?
				htmlFormElementTable(htmlSelect('ClassID',$classNames,1,$this->View->navigation->ClassID,false,'onChange="clearFields();document.we_form.elements[\'FolderID\'].value=objectDirs[document.we_form.elements[\'ClassID\'].options[document.we_form.elements[\'ClassID\'].selectedIndex].value];document.we_form.elements[\'FolderPath\'].value=objectPaths[document.we_form.elements[\'ClassID\'].options[document.we_form.elements[\'ClassID\'].selectedIndex].value];'.$this->topFrame.'.we_cmd(\'populateWorkspaces\');'.$this->topFrame.'.mark();" style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;"','value'),$l_navigation['class']) .
				$this->getHTMLWorkspace('class',$_firstClass) : '').
				'
			</div>
			<div id="fieldChooser" style="' . ($this->View->navigation->SelectionType!='category' ? 'display: block' : 'display: none') . '; width: ' . $this->_width_size . ';margin-top: '.$this->_margin_top.';">
			' . $this->getHTMLFieldChooser($l_navigation['title_field'],'TitleField',$this->View->navigation->TitleField,'putField',$this->View->navigation->SelectionType,($this->View->navigation->SelectionType=='classname' ? $this->View->navigation->ClassID : $this->View->navigation->DocTypeID)).'
			</div>
			' . $this->getHTMLDirSelector() . '
			<div id="catSort" style="' . ($this->View->navigation->SelectionType!='category' ? 'display: block' : 'display: none') . '; width: ' . $this->_width_size . ';">
			' . $this->getHTMLCategory() . '
			' . $this->getHTMLSort() . '
			</div>
			<div id="dynUrl" style="' . ($this->View->navigation->SelectionType=='category' ? 'display: block' : 'display: none') . '; width: ' . $this->_width_size . ';">
			'.
			$this->getHTMLLink('dynamic_')
			.'
			</div>
			<div style="width: ' . $this->_width_size . ';margin-top: '.$this->_margin_top.';">
			' . htmlFormElementTable(htmlTextInput('dynamic_Parameter',58,$this->View->navigation->Parameter,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size,0),$l_navigation['parameter']) . '
			</div>
			' . $this->getHTMLCount() .'
			' . $we_button->create_button_table(array(
								$we_button->create_button('preview', 'javascript:'.$this->topFrame.'.we_cmd("dyn_preview");'),
								($this->View->navigation->hasDynChilds() ? $we_button->create_button('delete_all', 'javascript:'.$this->topFrame.'.we_cmd("depopulate");')  : '')

				),10 , array('style'=>'margin-top:20px;')) .'
		</div>
		';


	}

	function getHTMLStatic($disabled=false) {
		global $l_navigation;

		$we_button = new we_button();

		$seltype = array('docLink'=>$l_navigation['docLink']);
		if(defined('OBJECT_TABLE')) {
			$seltype['objLink']=$l_navigation['objLink'];
		}

		$rootDirID = 0;
		$_cmd_doc = "javascript:we_cmd('openDocselector',(document.we_form.elements['LinkID'].value==0?'':document.we_form.elements['LinkID'].value),'".FILE_TABLE."','document.we_form.elements[\\'LinkID\\'].value','document.we_form.elements[\\'LinkPath\\'].value','','".session_id()."','$rootDirID','',".(we_hasPerm("CAN_SELECT_OTHER_USERS_FILES") ? 0 : 1).")";
		$_cmd_obj = defined('OBJECT_TABLE') ? "javascript:we_cmd('openDocselector',document.we_form.elements['LinkID'].value,'".OBJECT_FILES_TABLE."','document.we_form.elements[\\'LinkID\\'].value','document.we_form.elements[\\'LinkPath\\'].value','opener.".$this->topFrame.".we_cmd(\"populateWorkspaces\");','".session_id()."','$rootDirID','',".(we_hasPerm("CAN_SELECT_OTHER_USERS_OBJECTS") ? 0 : 1).")" : '';
		$_cmd_cat = "javascript:we_cmd('openCatselector',document.we_form.elements['LinkID'].value,'".CATEGORY_TABLE."','document.we_form.elements[\\'LinkID\\'].value','document.we_form.elements[\\'LinkPath\\'].value','opener.".$this->topFrame.".we_cmd(\"populateText\");opener.".$this->topFrame.".mark();','".session_id()."','$rootDirID')";

//		$_button_doc = $we_button->create_button('select', $_cmd_doc,true,100,22,'','',$disabled);
//		$_button_obj = $we_button->create_button('select', $_cmd_obj,true,100,22,'','',$disabled);
//		$_button_cat = $we_button->create_button('select', $_cmd_cat,true,100,22,'','',$disabled);

		$_button_doc = $we_button->create_button_table(array(
			$we_button->create_button('select', $_cmd_doc,true,100,22,'','',$disabled),
			$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["LinkID"].value=0;document.we_form.elements["LinkPath"].value="/";',true, 27, 22)),10);
		$_button_obj = $we_button->create_button_table(array(
			$we_button->create_button('select', $_cmd_obj,true,100,22,'','',$disabled),
			$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["LinkID"].value=0;document.we_form.elements["LinkPath"].value="/";',true, 27, 22)),10);
		$_button_cat = $we_button->create_button_table(array(
			$we_button->create_button('select', $_cmd_cat,true,100,22,'','',$disabled),
			$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["LinkID"].value=0;document.we_form.elements["LinkPath"].value="/";',true, 27, 22)),10);

		$_buttons = '<div id="docLink" style="display: '.($this->View->navigation->SelectionType=='docLink' ? 'inline' : 'none').'">' .
					$_button_doc .
					'</div>' .
					'<div id="objLink" style="display: '.($this->View->navigation->SelectionType=='objLink' ? 'inline' : 'none').'">' .
					$_button_obj .
					'</div>'.
					'<div id="catLink" style="display: '.($this->View->navigation->SelectionType=='catLink' ? 'inline' : 'none').'">' .
					$_button_cat .
					'</div>';

		$_path = id_to_path($this->View->navigation->LinkID,($this->View->navigation->SelectionType=='docLink' ? FILE_TABLE : ($this->View->navigation->SelectionType=='catLink' ? CATEGORY_TABLE : (defined('OBJECT_FILES_TABLE') ? OBJECT_FILES_TABLE : ''))));

		return '<div style="margin-top:'.$this->_margin_top.'">' .
		htmlFormElementTable(htmlTextInput('LinkPath',58,$_path,'','onchange="'.$this->topFrame.'.mark();" readonly','text',($this->_width_size-157),0),
			'',
			'left',
			'defaultfont',
			we_htmlElement::htmlHidden(array('name'=>'LinkID',"value"=>$this->View->navigation->LinkID)),
			getPixel(20,4),
			$_buttons
		) . '</div>' .
		$this->getHTMLWorkspace();

	}

	function getHTMLTab2(){
		global $l_navigation;

		/*if($this->View->navigation->hasDynChilds()) {
			return $this->getHTMLContentInfo();
		}*/

		$parts = array();
		$we_button = new we_button();

		$_seltype = array('doctype'=>$l_navigation['documents']);
		if(defined('OBJECT_TABLE')) {
			$_seltype['classname']=$l_navigation['objects'];
		}
		$_seltype['category']=$l_navigation['categories'];

		$_selection_block =
			$this->View->htmlHidden('CategoriesControl',(isset($_REQUEST['CategoriesCount']) ? $_REQUEST['CategoriesCount'] : 0)) .
			$this->View->htmlHidden('SortControl',(isset($_REQUEST['SortCount']) ? $_REQUEST['SortCount'] : 0)) .
			$this->View->htmlHidden('CategoriesCount',(isset($this->View->navigation->Categories) ? count($this->View->navigation->Categories) : '0')) .
			$this->View->htmlHidden('SortCount',(isset($this->View->navigation->Sort) ? count($this->View->navigation->Sort) : '0')) .
			'
			<div style="display: block;">
				<div style="display:'.($this->View->navigation->hasDynChilds() ? 'none' : 'block').';">
				' .
				htmlSelect('Selection',array('nodynamic'=>$l_navigation['no_dyn_content'], 'dynamic'=>$l_navigation['dyn_content']),1,$this->View->navigation->Selection,false,'style="width: ' . $this->_width_size . 'px;" onChange="toggle(\'dynamic\');setPresentation(\'dynamic\');setWorkspaces(\'\');'.$this->topFrame.'.mark();"','value',$this->_width_size) .
				'
				</div>
				<div id="dynamic" style="' . ($this->View->navigation->Selection=='dynamic' ? 'display: block;' : 'display: none;') .';margin-top:'.$this->_margin_top.'">
				'.
				htmlSelect('SelectionType',$_seltype,1,$this->View->navigation->SelectionType,false,'onChange="closeAllType();clearFields();toggle(this.value);setWorkspaces(this.value);setStaticSelection(this.value);'.$this->topFrame.'.mark();" style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;"','value',$this->_width_size) .
				$this->getHTMLDynamic() .
				'</div>
			</div>';

		array_push($parts,
					array(
						'headline' => $l_navigation['content'],
						'html' =>	$_selection_block,
						'space' => $this->_space_size,
					)
		);



		return $parts;
	}


	function getHTMLContentInfo(){
		global $l_navigation;

		$parts = array();
		$we_button = new we_button();

		$_sort = array();
		foreach ($this->View->navigation->Sort as $_i) {
			$_sort[] = $_i['field'] . '&nbsp;(' . ($_i['order']=='DESC' ? $l_navigation['descending'] : $l_navigation['ascending']) . ')';
		}

		$_table=new we_htmlTable(array('width'=>$this->_width_size,'cellpadding'=>'0','cellspacing'=>'0','border'=>'0','class'=>'defaultfont'),9,2);

		if($this->View->navigation->SelectionType=='doctype') {

			$_table->setCol(0,0,array('style'=>'font-weight: bold;'),$l_navigation['documents']);

			if(!empty($this->View->navigation->DocTypeID)){
				$_dt = f('SELECT DocType FROM '.DOC_TYPES_TABLE.' WHERE ID='.$this->View->navigation->DocTypeID,'DocType',new DB_WE());
				$_table->setCol(1,0,array('style'=>'font-weight: bold;'),$l_navigation['doctype'].':');
				$_table->setColContent(1,1,$_dt);
			}

		} else if($this->View->navigation->SelectionType=='category') {
			$_table->setCol(0,0,array('style'=>'font-weight: bold;'),$l_navigation['categories']);

		} else {
			$_table->setCol(0,0,array('style'=>'font-weight: bold;'),$l_navigation['objects']);
			$_cn = f('SELECT Text FROM '.OBJECT_TABLE.' WHERE ID='.$this->View->navigation->ClassID,'Text',new DB_WE());
			$_table->setCol(1,0,array('style'=>'font-weight: bold;'),$l_navigation['class'].':');
			$_table->setColContent(1,1,$_cn);

			$_table->setCol(2,0,array('style'=>'font-weight: bold;'),$l_navigation['workspace'].':');
			$_table->setColContent(2,1,id_to_path($this->View->navigation->WorkspaceID));

		}

		if($this->View->navigation->SelectionType!='category' && !empty($this->View->navigation->TitleField)) {
			$_table->setCol(3,0,array('style'=>'font-weight: bold;'),$l_navigation['title_field'].':');
			$_table->setColContent(3,1,$this->View->navigation->TitleField);
		}

		$_table->setCol(4,0,array('style'=>'font-weight: bold;'),$l_navigation['dir'].':');
		if($this->View->navigation->SelectionType=='doctype') {
			$_table->setColContent(4,1,id_to_path($this->View->navigation->FolderID,FILE_TABLE));
		} else if($this->View->navigation->SelectionType=='category') {
			$_table->setColContent(4,1,id_to_path($this->View->navigation->FolderID,CATEGORY_TABLE));
		} else if(defined('OBJECT_FILES_TABLE')){
			$_table->setColContent(4,1,id_to_path($this->View->navigation->FolderID,OBJECT_FILES_TABLE));
		}

		if($this->View->navigation->SelectionType!='category') {
			if(!empty($this->View->navigation->Categories)) {
				$_table->setCol(5,0,array('style'=>'font-weight: bold;'),$l_navigation['categories'].':');
				$_table->setColContent(5,1,implode('<br />',$this->View->navigation->Categories));
			}

			if(!empty($_sort)) {
				$_table->setCol(6,0,array('style'=>'font-weight: bold;'),$l_navigation['sort'].':');
				$_table->setColContent(6,1,implode('<br />',$_sort));
			}
		}

		if(!empty($this->View->navigation->Url) && $this->View->navigation->Url!='http://') {
			$_table->setCol(7,0,array('style'=>'font-weight: bold;'),$l_navigation['urlLink'].':');
			$_table->setColContent(7,1,$this->View->navigation->Url);
		}

		if(!empty($this->View->navigation->Paramter)) {
			$_table->setCol(8,0,array('style'=>'font-weight: bold;'),$l_navigation['parameter'].':');
			$_table->setColContent(8,1,$this->View->navigation->Parameter);
		}

		$_table->setCol(8,0,array('style'=>'font-weight: bold;'),$l_navigation['show_count'].':');
		$_table->setColContent(8,1,$this->View->navigation->ShowCount);

		$parts[] = array(
							'headline' => $l_navigation['content'],
							'html' =>	$_table->getHTMLCode(),
							'space' => $this->_space_size
		);

		$parts[] = array(
							'headline' => $l_navigation['entries'],
							'html' =>	htmlSelect('dynContent',$this->View->getItems($this->View->navigation->ID),20,'',false,'style="width: '.$this->_width_size.'px; height: 200; border: 1px solid #AAAAAA; margin: 0 0 ' . $this->_margin_bottom . ' 0;"'),
							'space' => $this->_space_size,
							'noline' => 0
		);

		$parts[] = array(
							'headline' => '',
							'html' => we_button::create_button_table(
									array(
											$we_button->create_button('preview', 'javascript:'.$this->topFrame.'.we_cmd("dyn_preview");'),
											$we_button->create_button('refresh', 'javascript:'.$this->topFrame.'.we_cmd("populate");'),
											$we_button->create_button('delete_all', 'javascript:'.$this->topFrame.'.we_cmd("depopulate");')
									)
							),
							'space' => $this->_space_size
		);

		return $parts;
	}

	function getHTMLEditorPreview() {


		require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/navigation/weNavigationItems.class.php');
		require_once($_SERVER['DOCUMENT_ROOT']."/webEdition/we/include/we_classes/html/we_multibox.inc.php");

		$we_button = new we_button();

		// build the page
		$out = '<table border="0" class="defaultfont" cellpadding="0" cellspacing="0">
		<tr>
			<td><iframe name="preview" style="background: white; border: 1px solid black; width: 640px; height: 150px" src="edit_navigation_frameset.php?pnt=previewIframe"></iframe></td>
		</tr>
		<tr>
			<td height="30"><label for="previewCode">' . $GLOBALS['l_navigation']['preview_code'] . '</label><br /></td>
		<tr>
			<td>' . we_htmlElement::htmlTextArea(array('name' => 'previewCode', 'id' => 'previewCode', 'style' => 'width: 640px; height: 200px;', 'class' => 'defaultfont'), $this->View->navigation->previewCode) . '</td>
		</tr>
		<tr>
			<td height="10"></td>
		<tr>
		<tr>
			<td align="right">' . we_button::create_button_table( array(
								$we_button->create_button('refresh', 'javascript: showPreview();'),
								$we_button->create_button('reset', 'javascript: document.getElementById("previewCode").value = "' . str_replace("\n", '\n' ,addslashes($this->View->navigation->defaultPreviewCode)) . '"')
								//,$we_button->create_button('new_template', 'javascript: '.$this->topFrame.'.we_cmd("create_template");')
							)
			) . '</td>
		</tr>
		</table>';


		return 	we_htmlElement::jsElement('
					function showPreview() {
						document.we_form.pnt.value="previewIframe";
						submitForm("preview");
					}
				') .
				$this->View->getCommonHiddens(array('pnt'=>'preview','tabnr'=>'preview')) .
				we_htmlElement::htmlHidden(array('name'=>'newone','value'=>($this->View->navigation->ID==0 ? 1 : 0))) .
				htmlDialogLayout($out, $GLOBALS['l_navigation']['preview']);
	}

	function getHTMLEditorPreviewIframe() {

		require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tagParser.inc.php');
		require_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tag.inc.php');

		$templateCode = $this->View->navigation->previewCode;

		// if id in template is same as id in session_navigation object,
		// use dynamic entries
		$pattern = '/parentid="(.*)"/';
		if( preg_match ( $pattern, $templateCode, $matches )) {

			if ($matches[1] == $this->View->navigation->ID) {
				$GLOBALS['initNavigationFromSession'] = true;
			}
		}

		// initialize a document (only for caching needed)
		include($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/we_webEditionDocument.inc.php');
		$GLOBALS['we_doc'] = new we_webEditionDocument();
		$GLOBALS['weNoCache'] = true;

		$tp = new we_tagParser();

		$tags = $tp->getAllTags($templateCode);
		$tp->parseTags($tags, $templateCode);

		eval('?>' . $templateCode);
	}


	function getHTMLProperties($preselect=''){
		global $l_navigation;

		$tabNr = isset($_REQUEST['tabnr']) ? ($_REQUEST['tabnr'])  : 1;

		if($this->View->navigation->IsFolder==0 && $tabNr!=1 && $tabNr!=3) {
			$tabNr = 1;
		}

		include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/html/we_multibox.inc.php');

		$out = '';

		$hiddens=array(	'cmd'=>'',
						'pnt'=>'edbody',
						'tabnr'=>$tabNr,
						'vernr'=>(isset($_REQUEST['vernr']) ? $_REQUEST['vernr'] : 0),
						'delayParam'=>(isset($_REQUEST['delayParam']) ? $_REQUEST['delayParam'] : '')
		);

		if($tabNr=='preview'){
			$out .= $this->getHTMLEditorPreview();
		} else {

			$out .=	we_htmlElement::htmlDiv(array('id' => 'tab1','style'=>($tabNr==1 ? 'display: block;' : 'display: none')),
					$this->View->getCommonHiddens($hiddens) .

					$this->View->htmlHidden('IsFolder',(isset($this->View->navigation->IsFolder) ? $this->View->navigation->IsFolder : '0')) .

					we_multiIconBox::getHTML('','100%', $this->getHTMLGeneral(),30,'',-1,'','',false,$preselect) .

					($this->View->navigation->IsFolder ?
						we_multiIconBox::getHTML('','100%',$this->getHTMLPropertiesGroup(),30,'',-1,'','',false,$preselect)
						:
						we_multiIconBox::getHTML('','100%',$this->getHTMLPropertiesItem(),30,'',-1,'','',false,$preselect)
					) .
					(($this->View->navigation->Selection=='static' || $this->View->navigation->IsFolder) ?
						$this->getHTMLAttributes() :
						''
					)
				) .
				($this->View->navigation->IsFolder ?
				(
					we_htmlElement::htmlDiv(array('id' => 'tab2','style'=>($tabNr==2 ? 'display: block;' : 'display: none')), we_multiIconBox::getHTML('','100%',$this->getHTMLTab2(),30,'',-1,'','',false,$preselect))
				)

				: '') .
				((defined('CUSTOMER_TABLE')) ?
					we_htmlElement::htmlDiv(array('id' => 'tab3','style'=>($tabNr==3 ? 'display: block;' : 'display: none')), we_multiIconBox::getHTML('','100%',$this->getHTMLTab3(),30,'',-1,'','',false,$preselect))
					: ''
				)
				;
		}

		return $out;

	}


	function getHTMLLeft(){

		$frameset=new we_htmlFrameset(array("framespacing"=>"0","border"=>"0","frameborder"=>"no"));
		$noframeset=new we_baseElement("noframes");

   		$frameset->setAttributes(array("rows"=>"1,*,40"));
    	$frameset->addFrame(array("src"=>HTML_DIR."frameheader.html","name"=>"treeheader","noresize"=>null,"scrolling"=>"no"));

		$frameset->addFrame(array("src"=>$this->frameset."?pnt=treeconst","name"=>"tree","noresize"=>null,"scrolling"=>"auto"));
		$frameset->addFrame(array("src"=>$this->frameset."?pnt=treefooter","name"=>"treefooter","noresize"=>null,"scrolling"=>"no"));

		// set and return html code
		$body=$frameset->getHtmlCode()."\n".we_baseElement::getHtmlCode($noframeset);

		return $this->getHTMLDocument($body);
	}


	function getHTMLTreeHeader(){
		return "";
	}

	function getHTMLTreeFooter(){

		$body=we_htmlElement::htmlBody(array("bgcolor"=>"white","background"=>"/webEdition/images/edit/editfooterback.gif","marginwidth"=>"5","marginheight"=>"0","leftmargin"=>"5","topmargin"=>"0"),
					'<div id="infoField" style="margin:5px; display: none;" class="defaultfont"></div>'
		);

		return $this->getHTMLDocument($body);
	}

	function getHTMLCmd(){
		$out="";

		if(isset($_REQUEST["pid"])){
			$pid=$_REQUEST["pid"];
		}
		else exit;

		if(isset($_REQUEST["offset"])){
			$offset=$_REQUEST["offset"];
		}
		else $offset=0;

		include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/navigation/weNavigationTreeLoader.php');

		$rootjs='';
		if(!$pid){
			$rootjs.='
			'.$this->Tree->topFrame.'.treeData.clear();
			'.$this->Tree->topFrame.'.treeData.add(new '.$this->Tree->topFrame.'.rootEntry(\''.$pid.'\',\'root\',\'root\'));
			';
		}

		$hiddens=we_htmlElement::htmlHidden(array('name'=>'pnt','value'=>'cmd')).
				 	we_htmlElement::htmlHidden(array('name'=>'cmd','value'=>'no_cmd'));

		$out.=we_htmlElement::htmlBody(array('bgcolor'=>'white','marginwidth'=>'10','marginheight'=>'10','leftmargin'=>'10','topmargin'=>'10'),
					we_htmlElement::htmlForm(array('name'=>'we_form'),
							$hiddens.
							we_htmlElement::jsElement($rootjs.$this->Tree->getJSLoadTree(weNavigationTreeLoader::getItems($pid,$offset,$this->Tree->default_segment,'')))
					)
		);

		return $this->getHTMLDocument($out);
	}

	function formFileChooser($width = '', $IDName = 'ParentID', $IDValue = '/', $cmd = '', $filter = '') {
		$we_button = new we_button();
	  	$button =  $we_button->create_button('select',"javascript:we_cmd('browse_server','document.we_form.elements[\\'$IDName\\'].value','$filter',document.we_form.elements['$IDName'].value);");

		return htmlFormElementTable(htmlTextInput($IDName,30,$IDValue,'','readonly','text',($this->_width_size-120),0),
			"",
			"left",
			"defaultfont",
			"",
			getPixel(20,4),
			we_hasPerm("CAN_SELECT_EXTERNAL_FILES") ? $button : "");
	}

	function getHTMLFieldChooser($title,$name,$value,$cmd,$type,$selection){

		$we_button = new we_button();
		$_disabled = !(($this->View->navigation->SelectionType=='classname' && $this->View->navigation->ClassID!=0) || ($this->View->navigation->SelectionType=='doctype' && $this->View->navigation->DocTypeID!=0));
		$_cmd = "javascript:var st=document.we_form.SelectionType.options[document.we_form.SelectionType.selectedIndex].value; var s=(st=='doctype' ? document.we_form.DocTypeID.options[document.we_form.DocTypeID.selectedIndex].value : document.we_form.ClassID.options[document.we_form.ClassID.selectedIndex].value);we_cmd('openFieldSelector','$cmd',st,s,0)";
		$_button = $we_button->create_button('select', $_cmd,true,100,22,'','',$_disabled,false);

		return htmlFormElementTable(htmlTextInput($name,58,$value,'','onchange="'.$this->topFrame.'.mark();"','text',($this->_width_size-120),0),
			$title,
			'left',
			'defaultfont',
			'',
			getPixel(20,4),
			$_button
		);


	}

	function getHTMLChooser($title,$table=FILE_TABLE,$rootDirID=0,$IDName='ID',$IDValue='0',$PathName='Path',$cmd='',$filter='text/webedition',$disabled=false,$showtrash=false){
		global $l_navigation;
		$we_button = new we_button();
		$_path = id_to_path($this->View->navigation->$IDName,$table);

		if($table == NAVIGATION_TABLE) {
			$_cmd = "javascript:we_cmd('openNavigationDirselector',document.we_form.elements['" . $IDName . "'].value,'document.we_form." . $IDName . ".value','document.we_form." . $PathName . ".value','".$cmd."')";
		} else {
			if($filter == 'folder') {
				$_cmd = "javascript:we_cmd('openSelector',document.we_form.elements['$IDName'].value,'$table','document.we_form.$IDName.value','document.we_form.$PathName.value','".$cmd."','".session_id()."','$rootDirID')";
			} else {
				$_cmd = "javascript:we_cmd('openDocselector',document.we_form.elements['$IDName'].value,'$table','document.we_form.$IDName.value','document.we_form.$PathName.value','".$cmd."','".session_id()."','$rootDirID','$filter',".(we_hasPerm("CAN_SELECT_OTHER_USERS_FILES") ? 0 : 1).")";
			}
		}


		if($showtrash) {
			$_button = $we_button->create_button_table(array(
					$we_button->create_button('select', $_cmd,true,100,22,'','',$disabled),
					$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["'.$IDName.'"].value=0;document.we_form.elements["'.$PathName.'"].value="/";',true, 27, 22)
			),10);
			$_width = 157;
		} else {
			$_button = $we_button->create_button('select', $_cmd,true,100,22,'','',$disabled);
			$_width = 120;
		}

		return htmlFormElementTable(htmlTextInput($PathName,58,$_path,'','readonly','text',($this->_width_size-$_width),0),
			$title,
			'left',
			'defaultfont',
			we_htmlElement::htmlHidden(array('name'=>$IDName,'value'=>$IDValue)),
			getPixel(20,4),
			$_button
		);

	}

	function getHTMLCategory() {
		global $l_navigation;

		$we_button = new we_button();

		$addbut = $we_button->create_button("add", "javascript:we_cmd('openCatselector','','" . CATEGORY_TABLE . "','','','fillIDs();opener.addCat(top.allPaths);opener.".$this->topFrame.".mark();')");
		$del_but = addslashes(we_htmlElement::htmlImg(array('src'=>IMAGE_DIR.'/button/btn_function_trash.gif','onclick'=>'javascript:#####placeHolder#####;'.$this->topFrame.'.mark();','style'=>'cursor: pointer; width: 27px;-moz-user-select: none;')));

		$variant_js = '
			var categories_edit = new multi_edit("categories",document.we_form,0,"' . $del_but . '",'.($this->_width_size-10).',false);
			categories_edit.addVariant();

			document.we_form.CategoriesControl.value = categories_edit.name;

		';
		if(is_array($this->View->navigation->Categories)){
			foreach ($this->View->navigation->Categories as $cat) {

				$variant_js .= '
					categories_edit.addItem();
					categories_edit.setItem(0,(categories_edit.itemCount-1),"'. $cat . '");
				';

			}
		}

		$variant_js .= '
			categories_edit.showVariant(0);
		';

		$js = we_htmlElement::jsElement($variant_js);

		$table = new we_htmlTable(array('id'=>'CategoriesBlock','style'=>'display: block;','cellpadding' => 0,'cellspacing' => 0,'border'=>0),5,1);

		$table->setColContent(0,0,getPixel(5,5));
		$table->setCol(1,0,array('class'=>'defaultfont'),$l_navigation['categories']);
		$table->setColContent(2,0,we_htmlElement::htmlDiv(array('id'=>'categories','class'=>'blockWrapper','style'=>'width: '.($this->_width_size).'px; height: 60px; border: #AAAAAA solid 1px;')));

		$table->setColContent(3,0,getPixel(5,5));

		$table->setCol(4,0,array('colspan'=>'2','align'=>'right'),
			$we_button->create_button_table(array(
					$we_button->create_button("delete_all", "javascript:removeAllCats()"),
					$addbut
				)
			)
		);


		return 	$table->getHtmlCode() .
				$js .
				we_htmlElement::jsElement('

							function removeAllCats(){
								'.$this->topFrame.'.mark();
								if(categories_edit.itemCount>0){
									while(categories_edit.itemCount>0){
										categories_edit.delItem(categories_edit.itemCount);
									}
								}
							}

							function addCat(paths){
								'.$this->topFrame.'.mark();
								var path = paths.split(",");
								var found = false;
								var j = 0;
								for (var i = 0; i < path.length; i++) {
									if(path[i]!="") {
										found = false;
										for(j=0;j<categories_edit.itemCount;j++){
											if(categories_edit.form.elements[categories_edit.name+"_variant0_"+categories_edit.name+"_item"+j].value == path[i]) {
												found = true;
											}
										}
										if(!found) {
											categories_edit.addItem();
											categories_edit.setItem(0,(categories_edit.itemCount-1),path[i]);
										}
									}
								}
								categories_edit.showVariant(0);
							}
					');
	}

	function getHTMLSort() {
		global $l_navigation;

		$we_button = new we_button();
		$_select_width = 145;
		$_disabled = !(($this->View->navigation->SelectionType=='classname' && $this->View->navigation->ClassID!=0) || ($this->View->navigation->SelectionType=='doctype' && $this->View->navigation->DocTypeID!=0));
		$addbut = $we_button->create_button("add", "javascript:selectFields();",true,100,22,'','',$_disabled,false,'_sort');
		$del_but = addslashes(we_htmlElement::htmlImg(array('src'=>IMAGE_DIR.'/button/btn_function_trash.gif','onclick'=>'javascript:#####placeHolder#####;setInsertBut()','style'=>'cursor: pointer; width: 27px;-moz-user-select: none; vertical-align: top;')));


		$js = we_htmlElement::jsElement('',array('src'=>JS_DIR.'utils/multi_edit.js?'.time()));

		$variant_js = '
			var sort_edit = new multi_edit("sort",document.we_form,0,"' . $del_but . '",'.($this->_width_size-220).',false);
			sort_edit.addVariant();

			document.we_form.SortControl.value=sort_edit.name;
		';


		$_select = new we_htmlSelect(array('name'=>'sortIndex_!#@SIPH@#!','size'=>'1','style'=>'width:'.$_select_width.';margin-right: 10px; vertical-align: top; border: 1px #AAAAAA solid;','onchange'=>$this->topFrame . '.mark();'));
		$_select->addOption('ASC',$l_navigation['ascending']);
		$_select->addOption('DESC',$l_navigation['descending']);

		if(is_array($this->View->navigation->Sort)){
			foreach ($this->View->navigation->Sort as $k=>$sort) {

				$_select->selectOption($sort['order']);

				$_row = '<div>' . ereg_replace("\r?\n",'',str_replace('_!#@SIPH@#!', ('_'.$k), $_select->getHtmlCode())) . $del_but .'</div>';

				$variant_js .= '
					sort_edit.addItem(\'' . $_row . '\');
					sort_edit.setItem(0,(sort_edit.itemCount-1),"'. $sort['field'] . '");
				';
			}
		}

		$variant_js .= '
			sort_edit.showVariant(0);
		';

		$js .= we_htmlElement::jsElement($variant_js);

		$table = new we_htmlTable(array('id'=>'SortBlock','style'=>'display: block;','cellpadding' => 0,'cellspacing' => 0,'border'=>0),5,1);

		$table->setColContent(0,0,getPixel(5,5));
		$table->setCol(1,0,array('class'=>'defaultfont'),$l_navigation['sort']);
		$table->setColContent(2,0,we_htmlElement::htmlDiv(array('id'=>'sort','class'=>'blockWrapper','style'=>'width: '.($this->_width_size).'px; height: 30px; border: #AAAAAA solid 1px;')));

		$table->setColContent(3,0,getPixel(5,5));

		$table->setCol(4,0,array('colspan'=>'2','align'=>'right'),
			'<div id="catAdd" style="display: ' . (count($this->View->navigation->Sort) ? 'none' : 'block').'">'.$addbut.'</div>'
		);

        $_strIfIsDefined_OBJECT_TABLE = defined('OBJECT_TABLE') ? 'var cl = document.we_form.ClassID.selectedIndex>-1 ? document.we_form.ClassID.options[document.we_form.ClassID.selectedIndex].value : "";' : '';
		return 	$table->getHtmlCode() .
				$js .
				we_htmlElement::jsElement('

							function selectFields() {
								'.$this->topFrame.'.mark();
								var st = document.we_form.SelectionType.selectedIndex>-1 ? document.we_form.SelectionType.options[document.we_form.SelectionType.selectedIndex].value : "";
								var dt = document.we_form.DocTypeID.selectedIndex>-1 ? document.we_form.DocTypeID.options[document.we_form.DocTypeID.selectedIndex].value : "";
								' . $_strIfIsDefined_OBJECT_TABLE . '


								we_cmd("openFieldSelector","addSort",st,(st=="doctype" ? dt : cl),0);

							}

							function removeAllSorts(){
								'.$this->topFrame.'.mark();
								while(sort_edit.itemCount>0){
									sort_edit.delItem(sort_edit.itemCount);
								}
								setInsertBut();
							}

							function addSort(paths){
								'.$this->topFrame.'.mark();
								var select = \'<div><select name="sortIndex_!#@SIPH@#!" size="1" style="width:'.$_select_width.';margin-right: 10px; vertical-align: top; border: 1px #bebebe solid;" onchange="'.$this->topFrame.'.mark();"><option value="ASC" selected>'.$l_navigation['ascending'].'<option value="DESC">'.$l_navigation['descending'].'</select><img src=\"/webEdition/images//button/btn_function_trash.gif\" onclick=\"javascript:#####placeHolder#####\;setInsertBut();" style=\"cursor: pointer; width: 27px;-moz-user-select: none; vertical-align: top;\"></div>\';
								var path = paths.split(",");
								for (var i = 0; i < path.length; i++) {
									if(path[i]!="") {
										sort_edit.addItem(select.replace("!#@SIPH@#!",sort_edit.itemCount));
										sort_edit.setItem(0,(sort_edit.itemCount-1),path[i]);
									}
								}
								sort_edit.showVariant(0);
								setInsertBut();
							}

							function setInsertBut() {
								if(sort_edit.itemCount==0){
									setVisible("catAdd",true);
								}else{
									setVisible("catAdd",false);
								}
								'.$this->topFrame.'.mark();
							}


					');
	}

	function getHTMLFieldSelector() {
		global $l_navigation;

		require_once($_SERVER['DOCUMENT_ROOT']."/webEdition/we/include/we_classes/html/we_multibox.inc.php");

		$we_button = new we_button();

		$_type = $_REQUEST['type']; // doctype || class
		$_selection = $_REQUEST['selection']; // templateid or classid
		$_cmd = $_REQUEST['cmd']; // js command
		$_multi = $_REQUEST['multi']; // js command

		$_js = $we_button->create_state_changer(false) . '
				function setFields() {
					var list = document.we_form.fields.options;

					var fields = new Array();
					for(i=0;i<list.length;i++){
						if(list[i].selected){
							fields.push(list[i].text);
						}
					}
					opener.'.$_cmd.'(fields.join(","));
					self.close();

				}

				function selectItem() {
					if(document.we_form.fields.selectedIndex>-1){
						switch_button_state("save", "save_enabled", "enabled");
					}
				}

		';

		if($_type=='doctype'){

			$_db = new DB_WE();
			$_fields = array();
			$_templates = f('SELECT Templates FROM ' . DOC_TYPES_TABLE . ' WHERE ID=' . $_selection,'Templates',$_db);
			$_ids = makeArrayFromCSV($_templates);

			include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/we_template.inc.php');
			foreach ($_ids as $_templateID) {
				$_template = new we_template();
				$_template->initByID($_templateID,TEMPLATES_TABLE);
				$_fields = array_merge($_fields,$_template->readAllVariantFields());
			}

		} else {
			if(defined('OBJECT_TABLE')) {

				include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_modules/object/we_object.inc.php');

				$_class = new we_object();
				$_class->initByID($_selection,OBJECT_TABLE);
				$_fields = $_class->readAllVariantFields();
			}
		}

		$_parts = array();


		$_parts[] = array(
			'headline'=>'',
			'html'=>	htmlSelect('fields',array_keys($_fields),20,'',($_multi ? true : false),'style="width: 300px; height: 200; border: 1px solid #AAAAAA; margin: ' . $this->_margin_bottom . ' 0 ' . $this->_margin_bottom . ' 0;" onClick="setTimeout(\'selectItem();\',100);"') ,
			'space' => 0
		);
		$button = $we_button->create_button_table(array(
								$we_button->create_button('save', 'javascript:setFields();',true,100,22,'','',true,false),
								$we_button->create_button('close', 'javascript:self.close();')));

		$_body=we_htmlElement::htmlBody(array("class"=>"weDialogBody","onLoad"=>"loaded=1;"),
					we_htmlElement::htmlForm(array("name"=>"we_form","onsubmit"=>"return false"),
						we_multiIconBox::getHTML('','100%',$_parts,30,"<div style=\"float:right;\">".$button."<div>",-1,'','',false,$l_navigation['select_field_txt'])
					)
		);

		return $this->getHTMLDocument($_body,we_htmlElement::jsElement($_js));

	}

	function getHTMLCount() {
		global $l_navigation;

		$_code = '<div style="width: '.$this->_width_size.'; margin-top: '.$this->_margin_top.'">' .
		htmlFormElementTable(
								htmlTextInput('ShowCount',30,$this->View->navigation->ShowCount,'','onBlur="var r=parseInt(this.value);if(isNaN(r)) this.value='.$this->View->navigation->ShowCount.'; else{ this.value=r; '.$this->topFrame.'.mark();}"','text',$this->_width_size,0),
								$l_navigation['show_count']
		).
		'</div>';

		return $_code;


	}

	function getHTMLDirSelector() {
		global $l_navigation;

		$we_button = new we_button();

		$rootDirID = 0;

//		$_button_doc = $we_button->create_button('select', "javascript:we_cmd('openDirselector',document.we_form.elements['FolderID'].value,'".FILE_TABLE."','document.we_form.elements[\\'FolderID\\'].value','document.we_form.elements[\\'FolderPath\\'].value','opener.".$this->topFrame.".mark();','".session_id()."','$rootDirID')");
//		$_button_obj = defined('OBJECT_TABLE') ? $we_button->create_button('select', "javascript:we_cmd('openDirselector',document.we_form.elements['FolderID'].value,'".OBJECT_FILES_TABLE."','document.we_form.elements[\\'FolderID\\'].value','document.we_form.elements[\\'FolderPath\\'].value','opener.".$this->topFrame.".mark();','".session_id()."',objectDirs[document.we_form.elements['ClassID'].options[document.we_form.elements['ClassID'].selectedIndex].value])") : '';
//		$_button_cat = $we_button->create_button('select', "javascript:we_cmd('openCatselector',document.we_form.elements['FolderID'].value,'".CATEGORY_TABLE."','document.we_form.elements[\\'FolderID\\'].value','document.we_form.elements[\\'FolderPath\\'].value','opener.".$this->topFrame.".mark();','".session_id()."','$rootDirID')");

		$_button_doc = $we_button->create_button_table(array(
			$we_button->create_button('select', "javascript:we_cmd('openDirselector',document.we_form.elements['FolderID'].value,'".FILE_TABLE."','document.we_form.elements[\\'FolderID\\'].value','document.we_form.elements[\\'FolderPath\\'].value','opener.".$this->topFrame.".mark();','".session_id()."','$rootDirID')"),
			$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["FolderID"].value=0;document.we_form.elements["FolderPath"].value="/";',true, 27, 22)),10);
		if(defined('OBJECT_TABLE')) {
			$_button_obj = $we_button->create_button_table(array(
				$we_button->create_button('select', "javascript:we_cmd('openDirselector',document.we_form.elements['FolderID'].value,'".OBJECT_FILES_TABLE."','document.we_form.elements[\\'FolderID\\'].value','document.we_form.elements[\\'FolderPath\\'].value','opener.".$this->topFrame.".mark();','".session_id()."',objectDirs[document.we_form.elements['ClassID'].options[document.we_form.elements['ClassID'].selectedIndex].value])"),
				$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["FolderID"].value=0;document.we_form.elements["FolderPath"].value="/";',true, 27, 22)),10);
		} else {
			$_button_obj = "";
		}
		$_button_cat = $we_button->create_button_table(array(
			$we_button->create_button('select', "javascript:we_cmd('openCatselector',document.we_form.elements['FolderID'].value,'".CATEGORY_TABLE."','document.we_form.elements[\\'FolderID\\'].value','document.we_form.elements[\\'FolderPath\\'].value','opener.".$this->topFrame.".mark();','".session_id()."','$rootDirID')"),
			$we_button->create_button('image:btn_function_trash', 'javascript:document.we_form.elements["FolderID"].value=0;document.we_form.elements["FolderPath"].value="/";',true, 27, 22)),10);

		$_buttons = '<div id="docFolder" style="display: '.(($this->View->navigation->SelectionType=='doctype') ? 'inline' : 'none').'">' .
					$_button_doc .
					'</div>' .
					'<div id="objFolder" style="display: '.($this->View->navigation->SelectionType=='classname' ? 'inline' : 'none').'">' .
					$_button_obj .
					'</div>'.
					'<div id="catFolder" style="display: '.($this->View->navigation->SelectionType=='category' ? 'inline' : 'none').'">' .
					$_button_cat.
					'</div>'
					;

		$_path = id_to_path($this->View->navigation->FolderID,(($this->View->navigation->SelectionType=='doctype') ? FILE_TABLE : ($this->View->navigation->SelectionType=='category' ? CATEGORY_TABLE : (defined('OBJECT_FILES_TABLE') ? OBJECT_FILES_TABLE : ''))));

		return we_htmlElement::htmlDiv(array('style'=>'margin-top:'.$this->_margin_top.';'),
				htmlFormElementTable(htmlTextInput('FolderPath',58,$_path,'','onchange="'.$this->topFrame.'.mark();" readonly','text',($this->_width_size-157),0),
					$l_navigation['dir'],
					'left',
					'defaultfont',
					we_htmlElement::htmlHidden(array('name'=>'FolderID',"value"=>$this->View->navigation->FolderID)),
					getPixel(20,4),
					$_buttons
				)
		);


	}

	function getHTMLDynPreview() {
		global $l_navigation;

		require_once($_SERVER['DOCUMENT_ROOT']."/webEdition/we/include/we_classes/html/we_multibox.inc.php");
		$we_button = new we_button();

		$_select = new we_htmlSelect(array('size'=>'20','style'=>'width: 420px; height: 200; border: 1px solid #AAAAAA; margin: ' . $this->_margin_bottom . ' 0 ' . $this->_margin_bottom . ' 0;'));

		$_items = $this->View->navigation->getDynamicEntries();

		foreach ($_items as $_k=>$_item) {
			$_txt = id_to_path($_item['id'],($this->View->navigation->SelectionType=='doctype') ? FILE_TABLE  : ($this->View->navigation->SelectionType=='category' ? CATEGORY_TABLE : OBJECT_FILES_TABLE));
			if(!empty($_item['field'])) {
				$_opt = we_htmlSelect::getNewOptionGroup(array('style'=>'font-weight: bold; font-style: normal; color: darkblue;','label'=>$_item['field']));
				$_opt->addChild(we_htmlSelect::getNewOption($_k,$_txt));
				$_select->addChild($_opt);
			} else {
				$_select->addOption($_k,$_txt);
			}
		}


		$_parts[] = array(
			'headline'=>'',
			'html'=>	htmlFormElementTable(
							$_select->getHtmlCode(),
							$this->View->navigation->SelectionType=='category' ? $l_navigation['categories'] : ($this->View->navigation->SelectionType=='classname' ? $l_navigation['objects'] : $l_navigation['documents'])
						) ,
			'space' => 0
		);


		$_body=we_htmlElement::htmlBody(array("class"=>"weDialogBody"),
					we_htmlElement::htmlForm(array('name'=>'we_form','onsubmit'=>'return false'),
						we_multiIconBox::getHTML('','100%',$_parts,30,'<div style="float:right;">'.$we_button->create_button('close', 'javascript:self.close();').'</div>',-1,'','',false,$l_navigation['dyn_selection'])
					)
		);

		return $this->getHTMLDocument($_body,'');

	}

	function getHTMLWorkspace($type='object',$defClassID=0,$field='WorkspaceID') {
		global $l_navigation;

		include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_tools/navigation/weDynList.class.php');

		$_wsid = array();

		if($type=='class'){

			if($this->View->navigation->SelectionType=='classname' && $this->View->navigation->ClassID){
				$_wsid = weDynList::getWorkspacesForClass($this->View->navigation->ClassID);
			} else if($defClassID) {
				$_wsid = weDynList::getWorkspacesForClass($defClassID);
			}

			return '<div id="objLinkWorkspaceClass" style="display: '.(($this->View->navigation->Selection=='dynamic') ? 'block' : 'none').';margin-top: '.$this->_margin_top.';">' .
				htmlFormElementTable(
					htmlSelect('WorkspaceIDClass',$_wsid,1,$this->View->navigation->WorkspaceID,false,'style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;" onChange="'.$this->topFrame.'.mark();"','value'),
					$l_navigation['workspace']
				) .
				'</div>';

		} else {

			if($field=='WorkspaceID') {
				if($this->View->navigation->SelectionType=='objLink' && $this->View->navigation->LinkID){
					$_wsid = weDynList::getWorkspacesForObject($this->View->navigation->LinkID);
				}

				return '<div id="objLinkWorkspace" style="display: '.(($this->View->navigation->SelectionType=='objLink' && ($this->View->navigation->WorkspaceID>-1)) ? 'block' : 'none').';margin-top: '.$this->_margin_top.';">' .
					htmlFormElementTable(
						htmlSelect('WorkspaceID',$_wsid,1,$this->View->navigation->WorkspaceID,false,'style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;" onChange="'.$this->topFrame.'.mark();"','value'),
						$l_navigation['workspace']
					) .
					'</div>';
			} else {
				if($this->View->navigation->FolderSelection=='objLink' && $this->View->navigation->LinkID){
					$_wsid = weDynList::getWorkspacesForObject($this->View->navigation->LinkID);
				}

				return '<div id="objLinkFolderWorkspace" style="display: '.(($this->View->navigation->FolderSelection=='objLink' && ($this->View->navigation->FolderWsID>-1)) ? 'block' : 'none').';margin-top: '.$this->_margin_top.';">' .
					htmlFormElementTable(
						htmlSelect('FolderWsID',$_wsid,1,$this->View->navigation->FolderWsID,false,'style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;" onChange="'.$this->topFrame.'.mark();"','value'),
						$l_navigation['workspace']
					) .
					'</div>';
			}
		}

	}

	function getHTMLLink($prefix='') {
		global $l_navigation;

		$we_button = new we_button();

		$_cmd = "javascript:we_cmd('openDocselector',(document.we_form.elements['".$prefix."UrlID'].value==0?'':document.we_form.elements['".$prefix."UrlID'].value),'".FILE_TABLE."','document.we_form.elements[\\'".$prefix."UrlID\\'].value','document.we_form.elements[\\'".$prefix."UrlIDPath\\'].value','opener.".$this->topFrame.".mark()','".session_id()."',0,'text/webedition',".(we_hasPerm("CAN_SELECT_OTHER_USERS_FILES") ? 0 : 1).")";

		$_path = id_to_path($this->View->navigation->UrlID);

		return  we_htmlElement::jsElement('
					function '.$prefix.'setLinkSelection(value){
						if(value=="intern"){
							setVisible("'.$prefix.'intern",true);
							setVisible("'.$prefix.'extern",false);
						} else {
							setVisible("'.$prefix.'intern",false);
							setVisible("'.$prefix.'extern",true);
						}

					}
				') .
				'<div id="'.$prefix.'LinkSelectionDiv" style="display: '.(($this->View->navigation->SelectionType=='catLink' || $this->View->navigation->SelectionType=='category') ? 'block' : 'none').';margin-top: '.$this->_margin_top.';">' .
				htmlFormElementTable(
					htmlSelect($prefix.'LinkSelection',array('intern'=>$l_navigation['intern'],'extern'=>$l_navigation['extern']),1,$this->View->navigation->LinkSelection,false,'style="width: ' . $this->_width_size . 'px; border: #AAAAAA solid 1px;" onChange="'.$prefix.'setLinkSelection(this.value);'.$this->topFrame.'.mark();"','value'),
					$l_navigation['linkSelection']
				) .
				'</div>
				<div id="'.$prefix.'intern" style="display: '.(($this->View->navigation->LinkSelection=='intern' && $this->View->navigation->SelectionType!='urlLink') ? 'block' : 'none').';margin-top: '.$this->_margin_top.';">
				' .
				htmlFormElementTable(htmlTextInput($prefix.'UrlIDPath',58,$_path,'','readonly','text',($this->_width_size-120),0),
					'',
					'left',
					'defaultfont',
					we_htmlElement::htmlHidden(array('name'=>$prefix.'UrlID','value'=>$this->View->navigation->UrlID)),
					getPixel(20,4),
					$we_button->create_button('select', $_cmd)
				)
				.'
				</div>
				<div id="'.$prefix.'extern" style="display: '.(($this->View->navigation->LinkSelection=='extern' || $this->View->navigation->SelectionType=='urlLink') ? 'block' : 'none').';margin-top: '.$this->_margin_top.';">' .
				htmlTextInput($prefix.'Url',58,$this->View->navigation->Url,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size)
				.
				'</div>
				<div style="margin-top: '.$this->_margin_top.';">'.
				htmlFormElementTable(
					htmlTextInput($prefix.'CatParameter',58,$this->View->navigation->CatParameter,'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),
					$l_navigation['catParameter']
				).
				'</div>'
				;


	}

	function getHTMLExitQuestion() {
		global $l_navigation;

		if(isset($_REQUEST['delayCmd']) && isset($_REQUEST['delayParam'])) {

			$_frame = 'opener.' . $this->topFrame;
			$_form = $_frame.'.document.we_form';

			$_yes = $_frame.'.hot=0;' . $_frame . '.we_cmd("save_navigation");self.close();';
			$_no =  $_frame.'.hot=0;' . $_frame . '.we_cmd("' . $_REQUEST['delayCmd'] . '","'.$_REQUEST['delayParam'].'");self.close();';
			$_cancel = 'self.close();';

			return
			'<html>
			<head>
			' .
			STYLESHEET . '
			</head>

			<body class="weEditorBody" onBlur="self.focus()">
					' . htmlYesNoCancelDialog($l_navigation['exit_doc_question'],IMAGE_DIR."alert.gif","ja","nein","abbrechen",$_yes,$_no,$_cancel) . '
			</body>

			</html>
			';
		}

	}

	function getHTMLCharsetTable(){

		include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/charsetHandler.class.php');

		$value = (isset($this->View->navigation->Charset) ? $this->View->navigation->Charset : "");

		$charsetHandler = new charsetHandler();

		$charsets = $charsetHandler->getCharsetsForTagWizzard();
		asort($charsets);
		reset($charsets);

		$table=new we_htmlTable(array("border"=>"0","cellpadding"=>"2","cellspacing"=>"0"),1,2);
		$table->setCol(0,0,null,htmlTextInput("Charset", 15, $value,'','','text',120));
		$table->setCol(0,1,null,htmlSelect("CharsetSelect", $charsets, 1, $value, false, "onblur='document.forms[0].elements[\"Charset\"].value=this.options[this.selectedIndex].value;' onchange='document.forms[0].elements[\"Charset\"].value=this.options[this.selectedIndex].value;document.we_form.submit();'",'value',($this->_width_size-120)));

		return $table->getHtmlCode();
	}

	function getHTMLDocument($body,$head=""){

		$head=
		'<title>'.WE_DEFAULT_TITLE.'</title>
		<meta http-equiv="expires" content="0">
		<meta http-equiv="pragma" content="no-cache">
		<meta http-equiv="content-type" content="text/html; charset='.$this->View->navigation->Charset.'">' .
		"\n" . STYLESHEET . "\n".$head;
		return we_htmlElement::htmlHtml(
					we_htmlElement::htmlHead($head).
					$body
		);
	}

	function getLangField($name,$value,$title,$width){
		$input = htmlTextInput("Attributes[$name]", 15, $value, "", '', "text" , $width-100 );
		$select = '<select style="width:100px;" class="defaultfont" name="'.$name.'_select" size="1" onchange="this.form.elements[\'Attributes['.$name.']\'].value=this.options[this.selectedIndex].value;this.selectedIndex=-1;">
						<option value=""></option>
						<option value="en">en</option>
						<option value="de">de</option>
						<option value="es">es</option>
						<option value="fi">fi</option>
						<option value="ru">ru</option>
						<option value="fr">fr</option>
						<option value="nl">nl</option>
						<option value="pl">pl</option>
					</select>';
		return htmlFormElementTable($input,$title,"left","defaultfont",$select);
	}

	function getRevRelSelect($type,$value,$title){
		$input = htmlTextInput("Attributes[$type]",15,$value,"",'',"text",$this->_width_size-100);
		$select = '<select name="'.$type.'_sel" class="defaultfont" size="1" style="width:100px;" onchange="this.form.elements[\'Attributes['.$type.']\'].value=this.options[this.selectedIndex].text;this.selectedIndex=0;">
		<option></option>
		<option>contents</option>
		<option>chapter</option>
		<option>section</option>
		<option>subsection</option>
		<option>index</option>
		<option>glossary</option>
		<option>appendix</option>
		<option>copyright</option>
		<option>next</option>
		<option>prev</option>
		<option>start</option>
		<option>help</option>
		<option>bookmark</option>
		<option>alternate</option>
		<option>nofollow</option>
		</select>
		';
		return htmlFormElementTable($input,$title,"left","defaultfont",$select);
	}

	function getHTMLAttributes() {
		global $l_navigation;

		$_parts = array();

		$_parts[] = array(
			'headline'=> '',
			'html'=>htmlAlertAttentionBox($l_navigation['linkprops_desc'],2,$this->_width_size),
			'space' => $this->_space_size,
			'noline' => 1
		);

		$_title =  htmlFormElementTable(
			htmlTextInput('Attributes[title]',30,$this->View->navigation->getAttribute('title'),'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),
			$l_navigation['title']
		);

		$_anchor = htmlFormElementTable(
			htmlTextInput('Attributes[anchor]',30,$this->View->navigation->getAttribute('anchor'),'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),
			$l_navigation['anchor']
		);

		$_target = htmlFormElementTable(
			targetBox('Attributes[target]',30,($this->_width_size-100),'',$this->View->navigation->getAttribute('target'),'"'.$this->topFrame.'.mark();"','text',100),
			$l_navigation['target']
		);

		$_link = htmlFormElementTable(
			htmlTextInput('Attributes[link_attribute]',30,$this->View->navigation->getAttribute('link_attribute'),'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),
			$l_navigation['link_attribute']
		);

		$_parts[] = array(
			'headline'=>$l_navigation['attributes'],
			'html'=>$_title . $_anchor . $_link . $_target,
			'space' => $this->_space_size,
			'noline' => 1
		);

		$_lang = $this->getLangField('lang',$this->View->navigation->getAttribute('lang'),$l_navigation['link_language'],$this->_width_size);
		$_hreflang = $this->getLangField('hreflang',$this->View->navigation->getAttribute('hreflang'),$l_navigation['href_language'],$this->_width_size);

		$_parts[] = array(
			'headline'=>$l_navigation['language'],
			'html'=>	$_lang .
						$_hreflang,
			'space' => $this->_space_size,
			'noline' => 1
		);

		$_accesskey = 	htmlFormElementTable(
							htmlTextInput('Attributes[accesskey]',30,$this->View->navigation->getAttribute('accesskey'),'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),
							$l_navigation['accesskey']
						);

		$_tabindex = 	htmlFormElementTable(
							htmlTextInput('Attributes[tabindex]',30,$this->View->navigation->getAttribute('tabindex'),'','onchange="'.$this->topFrame.'.mark();"','text',$this->_width_size),
							$l_navigation['tabindex']
						);

		$_parts[] = array(
			'headline'=> $l_navigation['keyboard'],
			'html'=>	$_accesskey . $_tabindex,
			'space' => $this->_space_size,
			'noline' => 1
		);

		$_relfield = $this->getRevRelSelect('rel',$this->View->navigation->getAttribute('rel'),'rel');
		$_revfield = $this->getRevRelSelect('rev',$this->View->navigation->getAttribute('rev'),'rev');

		$_parts[] = array(
			'headline'=> $l_navigation['relation'],
			'html'=>	$_relfield . $_revfield,
			'space' => $this->_space_size,
			'noline' => 1
		);

		$_input_width = 70;

		$_popup = new we_htmlTable(array('cellpadding'=>'5','cellspacing'=>'0'),4,4);

		$_popup->setCol(0,0,array('colspan'=>'2'),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_open'), 'Attributes[popup_open]', $l_navigation['popup_open'],false,"defaultfont",$this->topFrame.".mark();")
		);
		$_popup->setCol(0,2,array('colspan'=>'2'),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_center'), 'Attributes[popup_center]', $l_navigation['popup_center'],false,"defaultfont",$this->topFrame.".mark();")
		);

		$_popup->setCol(1,0,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[popup_xposition]',5,$this->View->navigation->getAttribute('popup_xposition'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['popup_x']
			)
		);
		$_popup->setCol(1,1,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[popup_yposition]',5,$this->View->navigation->getAttribute('popup_yposition'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['popup_y']
			)
		);
		$_popup->setCol(1,2,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[popup_width]',5,$this->View->navigation->getAttribute('popup_width'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['popup_width']
			)
		);

		$_popup->setCol(1,3,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[popup_height]',5,$this->View->navigation->getAttribute('popup_height'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['popup_height']
			)
		);


		$_popup->setCol(2,0,array(),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_status'), 'Attributes[popup_status]', $l_navigation['popup_status'],false,"defaultfont",$this->topFrame.".mark();")
		);
		$_popup->setCol(2,1,array(),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_scrollbars'), 'Attributes[popup_scrollbars]', $l_navigation['popup_scrollbars'],false,"defaultfont",$this->topFrame.".mark();")
		);
		$_popup->setCol(2,2,array(),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_menubar'), 'Attributes[popup_menubar]', $l_navigation['popup_menubar'],false,"defaultfont",$this->topFrame.".mark();")
		);

		$_popup->setCol(3,0,array(),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_resizable'), 'Attributes[popup_resizable]', $l_navigation['popup_resizable'],false,"defaultfont",$this->topFrame.".mark();")
		);
		$_popup->setCol(3,1,array(),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_location'), 'Attributes[popup_location]', $l_navigation['popup_location'],false,"defaultfont",$this->topFrame.".mark();")
		);
		$_popup->setCol(3,2,array(),
			we_forms::checkboxWithHidden($this->View->navigation->getAttribute('popup_toolbar'), 'Attributes[popup_toolbar]', $l_navigation['popup_toolbar'],false,"defaultfont",$this->topFrame.".mark();")
		);


		$_parts[] = array(
			'headline'=> $l_navigation['popup'],
			'html'=>	$_popup->getHTMLCode(),
			'space' => $this->_space_size,
			'noline' => 1
		);


		$wepos = weGetCookieVariable("but_weNaviAttrib");
		return we_multiIconBox::getHTML('weNaviAttrib','100%',$_parts,30,'',0,$l_navigation['more_attributes'],$l_navigation['less_attributes'],($wepos=='down'));

	}

	function getHTMLImageAttributes() {
		global $l_navigation;

		$_parts = array();
		$_input_width=70;
		$_img_props = new we_htmlTable(array('cellpadding'=>'5','cellspacing'=>'0','border'=>'0'),4,5);

		$_img_props->setCol(0,0,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_width]',5,$this->View->navigation->getAttribute('icon_width'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['icon_width']
			)
		);
		$_img_props->setCol(0,1,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_height]',5,$this->View->navigation->getAttribute('icon_height'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['icon_height']
			)
		);
		$_img_props->setCol(0,2,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_border]',5,$this->View->navigation->getAttribute('icon_border'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['icon_border']
			)
		);
		$_img_props->setCol(0,3,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_hspace]',5,$this->View->navigation->getAttribute('icon_hspace'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['icon_hspace']
			)
		);
		$_img_props->setCol(0,4,array(),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_vspace]',5,$this->View->navigation->getAttribute('icon_vspace'),'','onchange="'.$this->topFrame.'.mark();"','text',$_input_width),
				$l_navigation['icon_vspace']
			)
		);
		$_img_props->setCol(1,0,array('colspan'=>'5'),
			htmlFormElementTable(
				htmlSelect('Attributes[icon_align]',array(''=>'Default','top'=>'Top','middle'=>'Middle','bottom'=>'Bottom','left'=>'left','right'=>'Right','texttop'=>'Text Top','absmiddle'=>'Abd Middle','baseline'=>'Baseline','absbottom'=>'Abs Bottom'),1,$this->View->navigation->getAttribute('icon_align'),false,'style="width: '.($this->_width_size-50).'px;"'),
				$l_navigation['icon_align']
			)
		);
		$_img_props->setCol(2,0,array('colspan'=>'5'),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_alt]',5,$this->View->navigation->getAttribute('icon_alt'),'','onchange="'.$this->topFrame.'.mark();"','text',($this->_width_size-50)),
				$l_navigation['icon_alt']
			)
		);
		$_img_props->setCol(3,0,array('colspan'=>'5'),
			htmlFormElementTable(
				htmlTextInput('Attributes[icon_title]',5,$this->View->navigation->getAttribute('icon_title'),'','onchange="'.$this->topFrame.'.mark();"','text',($this->_width_size-50)),
				$l_navigation['icon_title']
			)
		);

		return $_img_props->getHTMLCode();

	}


	function getHTMLCustomerFilter() {
		global $l_navigation;

		$we_button=new we_button();



		$_filter_args = array();
		$this->db->query("SHOW FIELDS FROM " . CUSTOMER_TABLE);
		while ($this->db->next_record()) {
			$_filter_args[$this->db->f("Field")] = $this->db->f("Field");
		}

		$_filter_op = array(
			'0'=>'=',
			'1'=>'&lt;&gt;',
			'2'=>'&lt;',
			'3'=>'&lt;=',
			'4'=>'&gt;',
			'5'=>'&gt;='
			//,'6'=>'LIKE'
		);

		$_filter_lo = array(
			'AND'=>$l_navigation['and'],
			'OR'=>$l_navigation['or']
		);

		if(empty($this->View->navigation->CustomerFilter)) {
			$this->View->navigation->CustomerFilter = array(
				'AND'=>
					array(array(
						'operand1'=> 'id',
						'operator'=> '0',
						'operand2'=> ''
					)
				)
			);
		}

		$_i = 0;
		$_adv_row = '';
		$_first = 0;

		foreach ($this->View->navigation->CustomerFilter as $_key=>$_value) {

			foreach ($_value as $_k=>$_v) {

				if($_first==0){
					$_adv_row .= '
					<tr id="filterRow_'.$_i.'">
						<td colspan="2">
							'.
							htmlSelect('filterSelect_'.$_i,$_filter_args,1,$_v['operand1'],false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 280px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td>
							'.
							htmlSelect('filterOperation_'.$_i,$_filter_op,1,$_v['operator'],false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 50px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td colspan="2">
							<input name="filterValue_'.$_i.'" value="'.$_v['operand2'].'" type="text" class="defaultfont" style="border: #AAAAAA solid 1px; width: 210px;" onchange="'.$this->topFrame.'.mark();"/>
						</td>
					</tr>
					';
					$_i++;
					$_first = 1;
				} else {
					$_adv_row .= '
					<tr id="filterRow_'.$_i.'">
						<td>
							'.
							htmlSelect('filterLogic_'.$_i,$_filter_lo,1,$_key,false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 70px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td>
							'.
							htmlSelect('filterSelect_'.$_i,$_filter_args,1,$_v['operand1'],false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 200px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td>
							'.
							htmlSelect('filterOperation_'.$_i,$_filter_op,1,$_v['operator'],false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 50px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td>
							<input name="filterValue_'.$_i.'" value="'.$_v['operand2'].'" type="text" class="defaultfont" style="border: #AAAAAA solid 1px; width: 180px;" onchange="'.$this->topFrame.'.mark();"/>
						</td>
						<td>
							'.
							$we_button->create_button("image:btn_function_trash", "javascript:".$this->topFrame.".mark();delRow(".$_i.")")
							.'
						</td>
					</tr>
					';
					$_i++;
				}
			}
		}


		if(empty($_adv_row)) {
				$_adv_row = '
					<tr id="filterRow_'.$_i.'">
						<td colspan="2">
							'.
							htmlSelect('filterSelect_0',$_filter_args,1,'',false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 280px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td>
							'.
							htmlSelect('filterOperation_0',$_filter_op,1,'',false,'class="defaultfont" style="border: #AAAAAA solid 1px; width: 50px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"')
							.'
						</td>
						<td colspan="2">
							<input name="filterValue_0" value="" type="text" class="defaultfont" style="border: #AAAAAA solid 1px; width: 210px;" onchange="'.$this->topFrame.'.mark();"/>
						</td>
					</tr>
					';
		}


		$_filter_args_str = '';

		foreach ($_filter_args as $_str) {
			$_filter_args_str .= '<option value="'.$_str.'">'.$_str.'</option>';
		}

		$_filterTable ='
		<table border="0" cellpadding="0" cellspacing="2" width="560 height="50">
			<tbody id="filterTable">
				<tr>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
					<td></td>
				</tr>
				'.$_adv_row.'
			</tbody>
		</table>
		';

		$js = we_htmlElement::jsElement('

			function addRow() {
				var elem = document.getElementById("filterTable");
				newID = elem.rows.length - 1;
				if(elem){

					var newRow = document.createElement("TR");
        			newRow.setAttribute("id", "filterRow_" + newID);

        			var cell = document.createElement("TD");
        			cell.innerHTML=\'<select class="defaultfont" name="filterLogic_\'+newID+\'" size="1" style="border: #AAAAAA solid 1px; width: 70px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"><option value="AND">'.$l_navigation['and'].'</option><option value="OR">'.$l_navigation['or'].'</option></select>\';
        			newRow.appendChild(cell);

					cell = document.createElement("TD");
        			cell.innerHTML=\'<select class="defaultfont" name="filterSelect_\'+newID+\'" size="1" style="border: #AAAAAA solid 1px; width: 200px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();">'.$_filter_args_str.'</select>\';
        			newRow.appendChild(cell);

        			cell = document.createElement("TD");
        			cell.innerHTML=\'<select class="defaultfont" name="filterOperation_\'+newID+\'" size="1" style="border: #AAAAAA solid 1px; width: 50px; margin-right: 5px;" onchange="'.$this->topFrame.'.mark();"><option value="0">=</option><option value="1">&lt;&gt;</option><option value="2">&lt;</option><option value="3">&lt;=</option><option value="4">&gt;</option><option value="5">&gt;=</option><option value="6">LIKE</option></select>\';
        			newRow.appendChild(cell);

					cell = document.createElement("TD");
        			cell.innerHTML=\'<input name="filterValue_\'+newID+\'" type="text" style="border: #AAAAAA solid 1px; width: 180px;" onchange="'.$this->topFrame.'.mark();"/>\';
        			newRow.appendChild(cell);

        			cell = document.createElement("TD");
        			cell.innerHTML=\''.$we_button->create_button("image:btn_function_trash", "javascript:".$this->topFrame.".mark(); delRow('+newID+')").'\';
        			newRow.appendChild(cell);

        			elem.appendChild(newRow);
				}
			}

			function delRow(id) {
				var elem = document.getElementById("filterTable");
				if(elem){
					trows = elem.rows;
					rowID = "filterRow_" + id;

		        	for (i=0;i<trows.length;i++) {
		        		if(rowID == trows[i].id) {
		        			elem.deleteRow(i);
		        		}
		        	}

				}
			}

		');

		$_filter = new we_htmlTable(array('border'=>'0','cellpadding'=>'0','cellspacing'=>'2','width'=>'560','height'=>'50'),4,3);

		$_filter->setCol(0,0,array(),getPixel(20,5));

		$_filter->setCol(1,1,array('colspan'=>2),
			$_filterTable
		);

		$_filter->setCol(2,1,array('colspan'=>'2'),getPixel(10,5));

		$_filter->setColContent(3,1,$we_button->create_button("image:btn_function_plus", "javascript:addRow()"));


		return
		    $js .

		    we_forms::checkbox(1, (($this->View->navigation->ApplyFilter==1) ? true : false),"applyfiltercheck", $l_navigation["filter"],false,"defaultfont","".$this->topFrame.".mark();if(document.we_form.applyfiltercheck.checked) {document.we_form.ApplyFilter.value=1;document.getElementById('filterDiv').style.display='block'; } else { document.we_form.ApplyFilter.value=0;document.getElementById('filterDiv').style.display='none';}") .

			'<div id="filterDiv" style="display:'.(($this->View->navigation->ApplyFilter==1) ? 'block' : 'none').';margin-top: 5px;">
			'.
				$_filter->getHtmlCode()
			.'
			</div>';

	}



	function getHTMLTab3() {

		global $l_navigation;

		include_once($_SERVER["DOCUMENT_ROOT"]."/webEdition/we/include/"."we_tools/MultiDirChooser.inc.php");

		$we_button = new we_button();
		$parts = array();

		$_space_size = 50;

		array_push($parts,
					array(
						'headline' => '',
						'html' =>	we_forms::checkbox(1, (($this->View->navigation->LimitAccess==0) ? false : true), "limitaccesscheck", $l_navigation["limit_access"], false,"defaultfont","".$this->topFrame.".mark();if(document.we_form.limitaccesscheck.checked){ document.we_form.LimitAccess.value=1;document.getElementById('AccessControl').style.display='block'; } else { document.we_form.LimitAccess.value=0;document.getElementById('AccessControl').style.display='none';}"),
						'space' => $_space_size,
						'noline' => 1
					)
		);

		$addbut = $we_button->create_button("add", "javascript:we_cmd('openSelector','','" . CUSTOMER_TABLE . "','','','fillIDs();opener.addCustomers(top.allPaths);opener.".$this->topFrame.".mark();')");
		$del_but = addslashes(we_htmlElement::htmlImg(array('src'=>IMAGE_DIR.'/button/btn_function_trash.gif','onclick'=>'javascript:#####placeHolder#####;'.$this->topFrame.'.mark();','style'=>'cursor: pointer; width: 27px;-moz-user-select: none;')));

		$variant_js = '
			var customers_edit = new multi_edit("customers",document.we_form,0,"' . $del_but . '",'.($this->_width_size).',false);
			customers_edit.addVariant();

			document.we_form.CustomersControl.value = customers_edit.name;

		';
		if(is_array($this->View->navigation->Customers)){
			foreach ($this->View->navigation->Customers as $cus) {

				$variant_js .= '
					customers_edit.addItem();
					customers_edit.setItem(0,(customers_edit.itemCount-1),"'. $cus . '");
				';

			}
		}

		$variant_js .= '
			customers_edit.showVariant(0);
		';

		$table = new we_htmlTable(array('id'=>'CustomerBlock','style'=>'display: block;','cellpadding' => 0,'cellspacing' => 0,'border'=>0),6,2);

		$table->setColContent(0,0,getPixel(25,5));
		$table->setCol(1,1,array('class'=>'defaultfont'),$l_navigation['selected_customers']);
		$table->setCol(2,1,array('class'=>'defaultfont'),$l_navigation['customers']);
		$table->setColContent(3,1,we_htmlElement::htmlDiv(array('id'=>'customers','class'=>'blockWrapper','style'=>'width: '.($this->_width_size).'px; height: 60px; border: #AAAAAA solid 1px;')));

		$table->setColContent(4,1,getPixel(5,5));

		$table->setCol(5,1,array('colspan'=>'2','align'=>'right'),
			$we_button->create_button_table(array(
					$we_button->create_button("delete_all", "javascript:removeAllCustomers()"),
					$addbut
				)
			)
		);


		$_customer_selector = $table->getHtmlCode() .
				we_htmlElement::jsElement($variant_js) .
				we_htmlElement::jsElement('

							function removeAllCustomers(){
								'.$this->topFrame.'.mark();
								if(customers_edit.itemCount>0){
									while(customers_edit.itemCount>0){
										customers_edit.delItem(customers_edit.itemCount);
									}
								}
							}

							function addCustomers(paths){
								'.$this->topFrame.'.mark();
								var path = paths.split(",");
								var found = false;
								var j = 0;
								for (var i = 0; i < path.length; i++) {
									if(path[i]!="") {
										found = false;
										for(j=0;j<customers_edit.itemCount;j++){
											if(customers_edit.form.elements[customers_edit.name+"_variant0_"+customers_edit.name+"_item"+j].value == path[i]) {
												found = true;
											}
										}
										if(!found) {
											customers_edit.addItem();
											customers_edit.setItem(0,(customers_edit.itemCount-1),path[i]);
										}
									}
								}
								customers_edit.showVariant(0);
							}
		');


		$out =
		$this->View->htmlHidden('CustomersControl',(isset($_REQUEST['CustomersControl']) ? $_REQUEST['CustomersControl'] : 0)) .
		$this->View->htmlHidden('CustomersCount',(isset($this->View->navigation->Customers) ? count($this->View->navigation->Customers) : '0')) .
		$this->View->htmlHidden('LimitAccess',(isset($this->View->navigation->LimitAccess) ? count($this->View->navigation->LimitAccess) : '0')) .
		$this->View->htmlHidden('AllCustomers',(isset($this->View->navigation->AllCustomers) ? $this->View->navigation->AllCustomers : '0')) .
		$this->View->htmlHidden('ApplyFilter',(isset($this->View->navigation->ApplyFilter) ? $this->View->navigation->ApplyFilter : '0')) .
		'<div id="AccessControl" ' . ( ($this->View->navigation->LimitAccess == 1) ? 'style="display:block"' : 'style="display:none"') . '>' .
		we_forms::checkbox(1, (($this->View->navigation->AllCustomers==1) ? true : false),"allcustomerscheck", $l_navigation['customer_access'],false,"defaultfont",$this->topFrame.".mark(); if(document.we_form.allcustomerscheck.checked){ document.we_form.AllCustomers.value=1;document.getElementById('CustomerAccess').style.display='none'; } else { document.we_form.AllCustomers.value=0;document.getElementById('CustomerAccess').style.display='block';}") .
		'<br><div id="CustomerAccess" ' . ( ($this->View->navigation->AllCustomers==1) ? 'style="display:none"' : 'style="display:block"') . '>' .
			$_customer_selector .
		'</div>' .
		$this->getHTMLCustomerFilter() .
		'</div>';


		array_push($parts,
					array(
						'headline' => '',
						'html' =>	$out,
						'space' => $_space_size + 20,
						'noline' => 1
					)
		);

		return $parts;

	}


}

?>