<?php
	include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we.inc.php');
	include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/html/we_htmlElement.inc.php');
	include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/html/we_htmlTable.inc.php');
	include_once($_SERVER['DOCUMENT_ROOT'] . '/webEdition/we/include/we_classes/html/we_htmlSelect.inc.php');
	


	class weSearch {
		
		var $Operators = array(
				'!=' => '<>',
				'=' => '=',
				'<>' => '<>',
				'<' => '<',
				'>' => '>'
		);
		
		var $FieldMap = array(
				'id' => 'ID',
				'path' => 'Path',
				'text' => 'Text',
				'doctype' => 'DocType',
				'category' => 'Category',
				'contenttype' => 'ContentType',
				'isfolder' => 'IsFolder',
				'templateid' => 'TemplateID',
				'parentid' => 'ParentID',
				'tableid' => 'TableID',
				'mastertemplateid'=> 'MasterTemplateID'
				
				
		);
		
		function getSearchResults($name,$keyword,$searchany,$options,$res_num=0){

			$_exp_pos = strpos($keyword,'exp:');
			$_items = array();

			$keyword = trim($keyword);
			$name = trim($name);
			
			if($_exp_pos!==false) {
				$_items = $this->evaluateExp(substr($keyword,$_exp_pos+4),$options,$res_num);
				$keyword = trim(substr($keyword,0,$_exp_pos));
			}

			if(!empty($name)) {
				$_items = $this->searchName($name,$options,$_items);
			}

			if(!empty($keyword)) {
				$_items = $this->searchContent($name,$keyword,$searchany,$options,$_items,$res_num);
			}
			
			return $_items;
			
		}	
		
		function searchName($name,$options,$items=array()) {

			$_items = array();
			$_tables = $this->getTableArray($items,$options);
			
			foreach ($_tables as $_table => $_id) {
					$_ws = get_ws($_table);			
					$_query = 'SELECT * FROM '.$_table.' WHERE ' .
					'Text LIKE ("%' . $name . '%") ' . 
					(!empty($_id) ? ' AND ID IN (' . implode(',',$_id) . ')'  : '') . ';';
					
					$_db = new DB_WE();
					$_db->query($_query);
					while($_db->next_record()) {
						if(we_hasPerm('ADMINISTRATOR') || empty($_ws)) {
							$_items[] = array_merge($_db->Record,array('Table'=>$_table));
						} else if(in_workspace($_db->Record['ID'],$_ws,$_table)) {
							$_items[] = array_merge($_db->Record,array('Table'=>$_table));
						}
					}


			}
			
			return $_items;			
			
		}
		
		function searchContent($name,$keyword,$searchany,$options,&$items,$max_res){
			
			$_items = array();
			$_tables = array();
			
			$_tables = $this->getTableArray($items,$options);

			$_keyword_arr = explode(' ',$keyword);			

			foreach ($_tables as $_table => $_id) {
				
				$_keyword = '';
				$_keyword_a = array();
				
				$_ws = get_ws($_table);
				
				if($_table == FILE_TABLE || $_table == TEMPLATES_TABLE){

					foreach($_keyword_arr as $_key) {
					 	if(!empty($_key)) {
							$_keyword_a[] = CONTENT_TABLE.'.Dat LIKE "%' . addslashes(trim($_key)) . '%"';					 	
					 	}
					}
					if(!empty($keyword)) {
						if($searchany==0){
							$_keyword = ' AND (' . implode(' AND ',$_keyword_a) . ')';
						} else {
							$_keyword = ' AND (' . implode(' OR ',$_keyword_a) . ')';
						}
					}
								
					$_query = 'SELECT '.$_table.'.* FROM '.$_table.','.LINK_TABLE.','.CONTENT_TABLE.' WHERE 
					'.$_table.'.ID = '.LINK_TABLE.'.DID AND '.LINK_TABLE.'.DocumentTable = "'.$this->getDefaultTableName($_table).'" AND '.LINK_TABLE.'.Type = "txt" AND 
					'.LINK_TABLE.'.CID =  '.CONTENT_TABLE.'.ID '. $_keyword . (!empty($_id) ? ' AND '.$_table.'.ID IN (' . implode(',',$_id) . ')'  : '') . 
					($_table == TEMPLATES_TABLE ? 'AND '.LINK_TABLE.'.Name <> "completeData"' : '') .
					' AND '.$_table.'.Text LIKE ("%' . $name . '%")' . 
					' GROUP BY ' . $_table.'.ID LIMIT 0,' . $max_res;

					$_db = new DB_WE();

					$_db->query($_query);
					
					while($_db->next_record()) {
						if(we_hasPerm('ADMINISTRATOR') || empty($_ws)) {
							$_items[] = array_merge($_db->Record,array('Table'=>$_table));
						} else if(in_workspace($_db->Record['ID'],$_ws,$_table)) {
							$_items[] = array_merge($_db->Record,array('Table'=>$_table));
						}
					}

				} else if($_table == OBJECT_FILES_TABLE) {
					
					$_db = new DB_WE();
					$_meta = $_db->metadata(OBJECT_FILES_TABLE);
					$_fields = array();
					
					foreach($_meta as $_data) {
						$_fields[] = 'OF_' . $_data['name'];
					}
									
					$_max_id = f('SELECT MAX(TableID) AS maxid FROM ' . OBJECT_FILES_TABLE,'maxid',$_db);
					$_max_id++;
					
					$_temp = $_db->table_names(OBJECT_X_TABLE . '%');
					foreach($_temp as $_t) {
						$_existing[] = $_t['table_name'];
					}
					
					for($i=1;$i<$_max_id;$i++) {
						
						$_obj_table = OBJECT_X_TABLE . $i;
						
						if(in_array($_obj_table,$_existing)) {
							$_meta = $_db->metadata($_obj_table);
							$_fields_diff = array();
							
							foreach($_meta as $_data) {
								if(!in_array($_data['name'],$_fields) && $_data['name']!='ID'){
									$_s = array();
									foreach($_keyword_arr as $_key) {
										if(!empty($_key)) {
											$_s[] = $_data['name'] . ' LIKE "%' . addslashes(trim($_key)) . '%" ';
										}
										$_fields_diff[] = '(' . implode(($searchany == 0 ? ' AND ' : ' OR '),$_s) . ')';
									}
									
								}
							}
							
	
							$_query = 'SELECT '.OBJECT_FILES_TABLE.'.* FROM '. OBJECT_FILES_TABLE .','.$_obj_table.' WHERE 
							'.$_obj_table.'.OF_ID = '.OBJECT_FILES_TABLE.'.ID ' .
							(!empty($_id) ? ' AND '.OBJECT_FILES_TABLE.'.ID IN (' . implode(',',$_id) . ')'  : '') . 
							' AND (' . implode(' OR ',$_fields_diff) . ') 
							GROUP BY ' . OBJECT_FILES_TABLE . '.ID LIMIT 0,' . $max_res;
	
							$_db = new DB_WE();
							$_db->query($_query);
	
							while($_db->next_record()) {
								if(we_hasPerm('ADMINISTRATOR') || empty($_ws)) {
									$_items[] = array_merge($_db->Record,array('Table'=>OBJECT_FILES_TABLE));
								} else if(in_workspace($_db->Record['ID'],$_ws,$_table)) {
									$_items[] = array_merge($_db->Record,array('Table'=>OBJECT_FILES_TABLE));
								}
							}
						}									
						
					}

				} else if($_table == OBJECT_TABLE){
					
				}

			} 
			
			return $_items;

		}
	
		function evaluateExp($keyword,$options,$res_num=0){
			
			$keyword = $this->normalize($keyword);
			$_tokens = $this->tokenize($keyword);
			$_tokens = $this->translateOperators($_tokens);
			$_tables = $this->getTables($options);
			$_condition = $this->constructCondition($_tokens);

			$_result = array();
			$_db = new DB_WE();
			
			foreach ($_tables as $_table){

				$_query = "SELECT * FROM $_table $_condition LIMIT 0,$res_num";				
				$_db->query($_query);

				while ($_db->next_record()) {
					$_result[] = array_merge(	array(
													'Table' => $_table
												),
												$_db->Record
											);
				}
			}

	 		return $_result;
		}		
		
		function getTables($options){
			$_tables = array();
			foreach ($options as $option=>$value){
				if($value && $option  == FILE_TABLE && we_hasPerm('CAN_SEE_DOCUMENTS')) {
					$_tables[] = FILE_TABLE;
				}
				if($value && $option  == TEMPLATES_TABLE && we_hasPerm('CAN_SEE_TEMPLATES')) {
					$_tables[] = TEMPLATES_TABLE;	
				}
				if(defined('OBJECT_FILES_TABLE') && $value && $option  == OBJECT_FILES_TABLE && we_hasPerm('CAN_SEE_OBJECTFILES')) {
					$_tables[] = OBJECT_FILES_TABLE;
				}
				if(defined('OBJECT_TABLE') && $value && $option  == OBJECT_TABLE && we_hasPerm('CAN_SEE_OBJECTS')) {
					$_tables[] = OBJECT_TABLE;
				}				
								
			}
			return $_tables;
		}
		
		function getTableArray(&$items,$options) {
			
			$_tables = array();
			foreach ($options as $_table=>$_value){
				if($_value){
					$_tables[$_table] = array();
				}
			}
			
			if(!empty($items)){
	
				foreach ($items as $item){

					if(in_array($item['Table'],array_keys($_tables))){
						$_tables[$item['Table']][] = $item['ID'];	
					}

				}

			}			
			return $_tables;
		}		
		
		function getDefaultTableName($name) {
			switch ($name) {
				case FILE_TABLE: return 'tblFile';
				case TEMPLATES_TABLE: return 'tblTemplates';
				case OBJECT_TABLE: return 'tbObject';
				case OBJECT_FILES_TABLE: return 'tblObjectFile';
				case DOC_TYPES_TABLE: return 'tblDocTypes';
				case CATEGORY_TABLE: return 'tblCategory';
			}
			
			return $name;
		}		
				
		function hasOperator($string) {
			
			foreach(array_keys($this->Operators) as $key) {
				if(strpos($string,$key)!==false) {
					return true;
				}
			}
			return false;
		}
		
		
		function tokenize($keyword) {

			$array=array();
	
			$array['AND']=array();
			$array['OR']=array();
			$array['AND NOT']=array();
			
			$ident = 'AND';
			$array[$ident][0] = '';

			$word = '';
			
			for($i=0;$i<strlen($keyword);$i++) {
				
				$word .=$keyword[$i];

				if($keyword[$i]==' ') {
					
					switch (strtolower(trim($word))) {
						case 'and' :
							$ident = 'AND';
							$array[$ident][] = '';
						break;

						case 'or':
							$ident = 'OR';
							$array[$ident][] = '';
						break;

						case 'not':
							$ident = 'AND NOT';
							$array[$ident][] = '';
						break;
						default:
							$_count = count($array[$ident]) -1;
							$array[$ident][$_count] .= $word;
					}
					$word = '';
					
				}

			}
			
			$array[$ident][count($array[$ident])-1] .= $word;
			
			return $array;
			
		}
		
		
		
		function tokenize2($keyword) {
			
			$arr = explode(' ', $keyword);
			$sWhere='';
			$ranking = '0';

			$first='';
			$array=array();
	
			$array['AND']=array();
			$array['OR']=array();
			$array['AND NOT']=array();
	
			$array['AND'][]=$arr[0];
	
			for ($i=1; $i<count($arr); $i++) {
				if ((strtolower($arr[$i])=='and')||(strtolower($arr[$i])=='or')||(strtolower($arr[$i])=='not')) {
	
					if (strtolower($arr[$i])=='not') {
						$i++;						
						if($this->hasOperator($arr[$i])) {							
							$array['AND NOT'][count($array['NOT'])]=$arr[$i];
						} else {
							$array['AND NOT'][count($array['NOT'])-1].=$arr[$i];
						}
					}
					else if (strtolower($arr[$i])=='and') {
						$i++;
						
						if($this->hasOperator($arr[$i])) {							
							$array['AND'][count($array['AND'])]=$arr[$i];
						} else {
							$array['AND'][count($array['AND'])-1].=$arr[$i];
						}
						
					}
					else if (strtolower($arr[$i])=='or') {
						$i++;
						if($this->hasOperator($arr[$i])) {							
							$array['OR'][count($array['OR'])]=$arr[$i];
						} else {
							$array['OR'][count($array['OR'])-1].=$arr[$i];
						}						
						
					}
				} else {
					if($this->hasOperator($arr[$i])) {							
						$array['AND'][count($array['AND'])]=$arr[$i];
					} else {
						$array['AND'][count($array['AND'])-1].=$arr[$i];
					}
				}
			}
			
			return $array;
		}
		
		function getExpression($string) {
			$_arr = array();
			
			foreach($this->Operators as $_k => $_v) {
				if(eregi($_k,$string)){
					$_arr = explode($_k,$string);
					$_expr = array(
						'operand1' => trim($this->fixFieldNames($_arr[0])),
						'operator' => trim($_v),
						'operand2' => trim($this->replaceSpecChars(stripslashes($_arr[1])))
					);
					
					if($_expr['operator']=='=' && ereg('%',$_expr['operand2'])){
						$_expr['operator']='LIKE';						
					}
				
					if(($_expr['operator']=='!=' || $_expr['operator']=='<>') && ereg('%',$_expr['operand2'])){
						$_expr['operator']='NOT LIKE';						
					}
					
					$this->getTransaltedExpression($_expr);
					
					if(!$this->isField($_expr['operand1'])) {
						$_expr['operand1'] = implode('',$_expr);
						unset($_expr['operator']);
						unset($_expr['operand2']);
					}

					break;
				}
			}
			
			if(!isset($_expr)){
				$_expr['operand1'] = $string;
			}
			
			return $_expr;
						
		}

		function getTransaltedExpression(&$_expr) {

				if(($_expr['operand1']=='DocType')){
					if(ereg('\*',$_expr['operand2'])) {
						$_expr['operand2'] = f('SELECT ID FROM ' . DOC_TYPES_TABLE .' WHERE DocType LIKE "' . str_replace("*","%",$_expr['operand2']) . '";','ID',new DB_WE());
					} else {						
						$_expr['operand2'] = f('SELECT ID FROM ' . DOC_TYPES_TABLE .' WHERE DocType LIKE "' . $_expr['operand2'] . '";','ID',new DB_WE());
					}
					// if operand2 is empty make some impossible condition
					if(empty($_expr['operand2']) && ($_expr['operator']=='LIKE' || $_expr['operator']=='=')) {
						$_expr['operand2'] = uniqid(time());
					}
				}

				if(($_expr['operand1']=='Category')){
					$_expr['operand2'] = ',' . f('SELECT ID FROM ' . CATEGORY_TABLE .' WHERE Text="' . $_expr['operand2'] . '";','ID',new DB_WE()) . ',';
					if($_expr['operator']=='=') {
						$_expr['operator']='LIKE';
					}
					if($_expr['operator']=='!=') {
						$_expr['operator']='NOT LIKE';
					}
					// if operand2 is empty make some impossible condition
					if(empty($_expr['operand2']) && $_expr['operator']=='LIKE') {
						$_expr['operand2'] = uniqid(time());
					}
				}

				if(ereg('\*',$_expr['operand2'])) {
					$_expr['operator'] = 'LIKE';
					$_expr['operand2'] = str_replace("*","%",$_expr['operand2']);
				}
		}
		
		
		function fixFieldNames($name) {

			foreach($this->FieldMap as $_k => $_v) {
				if(eregi("^".$_k."$",$name)){
					return $_v;				
				}
			}
			
						
			return $name;
		}
		
		function isField($field) {			
			return in_array($field,$this->FieldMap);
		}
		
		function replaceSpecChars($string) {
			$string= trim($string);
			$string= eregi_replace('\*','%',$string);
			$string= trim($string,'"');
			$string= trim($string,"'");
			return $string;
		}
		
		function translateOperators($tokens) {

			$_tokens = $tokens;
			foreach ($_tokens as $_lop => $_slots){
				foreach($_slots as $_key => $_value){

					$tokens[$_lop][$_key] = $this->getExpression ($_value);

				}
			}
			return $tokens;
		}
		
		function normalize($keyword){
			foreach ($this->Operators as $_operator) {
				$keyword = eregi_replace("[ ]*" . $_operator ."[ ]*",$_operator,$keyword);
			}
			return $keyword;
		}

		
		
		function constructCondition(&$_tokens) {

			$_condition = '';
			foreach ($_tokens as $_log=>$_token){
				$_word = array();
				$_conditions = array();
				foreach ($_token as $_op){
					if(count($_op)<3) {
						$_word[] = ' ' . $_op['operand1'] . ' ';
					}else {
						$_word[] = $_op['operand1'] . ' ' . $_op['operator'] . ' "' . addslashes($_op['operand2']) . '"';					
					}
				}
				if(!empty($_word)) {
						$_conditions[] = implode(" $_log ", $_word);
				}

				if(count($_conditions)) {
					if(empty($_condition)) {
						$_condition.= implode(" $_log ",$_conditions);
					} else {
						$_condition.= " $_log " . implode(" $_log ",$_conditions);
					}
				}

			}

			if($_condition!=''){
				$_condition=" WHERE $_condition ORDER BY Text";
			}
			
			return $_condition;
			
		}
		
		function constructObjCondition(&$_tokens,&$_tables) {
			
			foreach ($_tokens as $_log=>$_token){
				$_word = array();
				$_conditions = array();
				foreach ($_token as $_op){
					if(count($_op)<3) {
						$_word[] = ' ' . $_op['operand1'] . ' ';
					}else {
						$_word[] = $_op['operand1'] . ' ' . $_op['operator'] . ' "' . addslashes($_op['operand2']) . '"';					
					}
				}
				if(!empty($_word)) {
						$_conditions[] = implode(" $_log ", $_word);
				}

				if(count($_conditions)) {
					if(empty($_condition)) {
						$_condition.= implode(" $_log ",$_conditions);
					} else {
						$_condition.= " $_log " . implode(" $_log ",$_conditions);
					}
				}

			}

			if($_condition!=''){
				$_tables_arr = explode($_tables,',');
				foreach ($_tables_arr as $_k=>$_v) {
					if($_v==OBJECT_FILES_TABLE){
						$_tables_arr[$_k] = $_v . '.ID';
					} else {
						$_tables_arr[$_k] = $_v . '.OF_ID';
					}
				}
				
				$_condition=' WHERE (' . implode('=',$_tables_arr) . ") AND $_condition ORDER BY Text";
			}
			
			return $_condition;
			
		}		
		
		
	}
	
?>